<?php 
include_once 'htmllib/lib/include.php';

//array('add-under-class', 'add-under-name', 'subaction');

initProgram('admin');

$params = parse_opt($argv);

// action parameter is mandatory
if (!isset($params['action']))
{
	echo 'Action parameter is mandatory, class and name.' . PHP_EOL;
	exit;
}
else
{
	$action = $params['action'];
	
	try
	{
		switch($action)
		{
			case 'add':
				$list = __cmd_desc_add($params);
			break;
			case 'delete':
				$list = __cmd_desc_delete($params);
			break;
			case 'simplelist':
				$list = __cmd_desc_simplelist($params);
			break;
			case 'update':
				$list = __cmd_desc_update($params);
			break;
			case 'getproperty':
				$list = __cmd_desc_getproperty($params);
			break;
		}
		
		if ($list)
		{
			if (isset($params['output-type']))
			{
				if ($params['output-type'] === 'json')
				{
					$out = json_encode($list);
					print($out);
				}
				else if ($params['output-type'] === 'serialize')
				{
					$out = serialize($list);
					print($out);
				}
			}
			else
			{
				foreach($list as $l) {
					print("$l\n");
				}
			}
		}
		else
		{
			echo $action . ' succesfully executed.' . PHP_EOL;
		}
		
		exit(0);
	}
	catch (exception $e)
	{
		echo $e->__full_message . PHP_EOL;
		exit(8);
	}
}