<?php 
require_once 'htmllib/lib/include.php';
require_once 'lib/updatelib.php';

function cp_dbfile()
{
	global $gbl, $sgbl, $login, $ghtml;

	$progname = $sgbl->getProductName();
	$binary = '/usr/bin/' . $progname . 'db';
	
	echo 'Creating binary ' . $progname . 'db' . PHP_EOL;
	lxfile_cp('../sbin/' . $progname . 'db', $binary);
	lxfile_generic_chmod($binary, '0755');
}

function fix_hordedb_proper() //Not used on tmpupdatecleanup, deprecated?
{
    lxshell_php('../bin/misc/lxinstall_hordegroupware_db.php');
}

function os_createLowMem() //Not used on tmpupdatecleanup, deprecated?
{
    global $sgbl;
    
    system("yum -y install --nosig webalizer lxjailshell autorespond unzip lxlighttpd lxphp >/dev/null 2>&1 &");
    lxfile_touch("../etc/flag/lowmem.flag");

    if (!lxfile_exists("/proc/user_beancounters") && !lxfile_exists("/proc/xen")) {
        if (!lxshell_return("diff", "../file/lowmem/my.cnf.lowmem", "/etc/my.cnf")) {
            lxfile_cp("/etc/lowmem.saved.my.cnf", "/etc/my.cnf");
            createRestartFile("mysqld");
        }
        return;
    }

    if (lxfile_exists($sgbl->getEtc() . 'flag/lowmem.flag')) {

        if (!lxfile_exists("/etc/lowmem.saved.my.cnf")) {
            lxfile_cp("/etc/my.cnf", "/etc/lowmem.saved.my.cnf");
            lxfile_cp("../file/lowmem/my.cnf.lowmem", "/etc/my.cnf");
            createRestartFile('mysql');
            createRestartFile('courier-imap');
        }
        //lxfile_cp("../file/lowmem/spamassassin.lowmem", "/etc/sysconfig/spamassassin");
    }
}

exit_if_another_instance_running();
debug_for_backend();

$program = $sgbl->getProductName();
$opt = parse_opt($argv);

if ($opt['type'] === 'master')
{
    initProgram('admin');

    $flg = '__path_program_start_vps_flag';

    if (!lxfile_exists($flg))
    {
        set_login_skin_to_feather();
    }
}
else
{
    $login = new Client(null, null, 'update');
}

echo 'Executing UpdateCleanup. This can take some time. Please be patient.' . PHP_EOL;
log_log("update", "Executing Updatecleanup");

//
// Check for lxlabs yum repo file and if exists
// Change to lxcenter repo file
//
if (lxfile_exists("/etc/yum.repos.d/lxlabs.repo"))
{
    print("Delete old repo's\n");
    lxfile_mv("/etc/yum.repos.d/lxlabs.repo","/etc/yum.repos.d/lxlabs.repo.lxsave");
    system("rm -f /etc/yum.repos.d/lxlabs.repo");
    print("Removed lxlabs.repo\n");

    //print("Installing lxcenter.repo\n"); // @todo Remove this or install only qpanel.repo
    //system("wget -O /etc/yum.repos.d/lxcenter.repo http://download.lxcenter.org/lxcenter.repo");

    echo 'Installing yum-protectbase plugin' . PHP_EOL;
    system('yum install -y -q yum-protectbase');
    echo 'Done.' . PHP_EOL;
}
//

	//
	// Fix vulnerability within webmail
// If the flag isn't found, run the fix
//
// Disabled in Kloxo 6.1.4
//if (!lxfile_exists("/usr/local/lxlabs/kloxo/file/webmailReset")) {
//	system("/usr/local/lxlabs/ext/php/php /usr/local/lxlabs/kloxo/bin/misc/secure-webmail-mysql.phps");
//	system("/bin/rm /usr/local/lxlabs/kloxo/bin/misc/secure-webmail-mysql.phps");
//}

// Remove Flagfile in Kloxo 6.1.4, this can be removed in 6.1.4+
/*if (lxfile_exists("/usr/local/lxlabs/kloxo/file/webmailReset")) {
system("/bin/rm /usr/local/lxlabs/kloxo/file/webmailReset");
}*/

// Fix #388 - phpMyAdmin config.inc.php permission
echo 'Checking phpMyAdmin config.inc.php permission' . PHP_EOL;

$correct_perm = '0644';

$phpmyadmin_config_file = "/usr/local/lxlabs/$program/httpdocs/thirdparty/phpMyAdmin/config.inc.php";

if(lxfile_exists($phpmyadmin_config_file))
{
    $check_perm = substr(decoct(fileperms($phpmyadmin_config_file) ), 2);

    if ($check_perm != $correct_perm) {
        lxfile_unix_chmod($phpmyadmin_config_file, '0644');
    }
}

if (lxfile_exists('.svn') || lxfile_exists('.git') /*|| lxfile_exists('.bzr')*/)
{
    echo 'Development version found. Exiting.' . PHP_EOL;
    exit;
}

// If master it will update all the slave for that master
if ($opt['type'] === 'master')
{
    $sgbl->slave = false;

    if (!is_secondary_master())
    {
        updateDatabaseProperly();
        fixExtraDB();
        doUpdateExtraStuff();
        echo 'Loading drivers' . PHP_EOL;
        lxshell_return('__path_php_path', '../bin/common/driverload.php');
    }

    update_all_slave();
    cp_dbfile();
}
else
{
    $sgbl->slave = true;
}

// Update himself if is not a secondary master
if (!is_secondary_master())
{
    echo 'Running update cleanup on main master ...' . PHP_EOL;

    $program = $sgbl->getProductName();
 
    $updater = new Updater();
    $updater->createProgramService($program); //For kloxo right way
    $updater->createProgramService('qpanel'); //Temporal for qpanel
    $updater->copyPHPini();
     
    $updater->restartInitProgram($program);
    $updater->restartInitProgram('qpanel');
     
    $updater->downloadThirparty();

    $updater->installPHPgd();
    $updater->installBogofilter();
    $updater->migrateClientsDir();
    $updater->checkPhpMyAdminConfig();
     
    call_with_flag('installgroupwareagain');
    
    $desc = uuser::getUserDescription('admin');
    $list = posix_getpwnam('admin');
    
    if ($list && ($list['gecos'] !== $desc))
    {
        lxshell_return('usermod', '-c', $desc, 'admin');
    }
    
    // TODO: php six four symlink remove when lxphp 64bit is ready!
    if (os_is_php_six_four())
    {
        $ver = get_package_version('kloxophpsixfour');
        installWithVersion('/usr/lib/kloxophp', 'kloxophpsixfour', $ver);
    
        if (!lxfile_exists('/usr/lib/php'))
        {
            lxfile_symlink('/usr/lib64/php', '/usr/lib/php');
        }
    }
    else
    {
        echo 'Getting package kloxophp' . PHP_EOL;
        $ver = get_package_version('kloxophp');
        installWithVersion('/usr/lib/kloxophp', 'kloxophp', $ver);
    }
    
    $ver = get_package_version('lxwebmail');
    installWebmail($ver);
    
    $lxawstats_version = get_package_version('lxawstats');
    $updater->installAwstats($lxawstats_version);
    
    $rouncube_database_config = '/home/kloxo/httpd/webmail/roundcube/config/db.inc.php';
    if (!lxfile_exists($rouncube_database_config))
    {
        echo 'Creating RoundCube database config' . PHP_EOL;
        lxfile_cp("../file/webmail-chooser/db.inc.phps", $rouncube_database_config);
    }
    
    lxfile_mkdir("/etc/lighttpd/conf/kloxo");
    lxfile_mkdir("/var/bogofilter");
    lxfile_mkdir("/home/kloxo/httpd/lighttpd");
    
    if(lxfile_exists('/home/admin/domain/'))
    {
        rmdir('/home/admin/domain/');
    }
    
    if(lxfile_exists('/home/admin/old/'))
    {
        rmdir('/home/admin/old/');
    }
    
    if(lxfile_exists('/home/admin/cgi-bin/'))
    {
        rmdir('/home/admin/cgi-bin/');
    }
    
    if(lxfile_exists('/etc/skel/Maildir/new'))
    {
        rmdir('/etc/skel/Maildir/new');
    }
    
    if(lxfile_exists('/etc/skel/Maildir/cur'))
    {
        rmdir('/etc/skel/Maildir/cur');
    }
    
    if(lxfile_exists('/etc/skel/Maildir/tmp'))
    {
        rmdir('/etc/skel/Maildir/tmp');
    }
    
    if(lxfile_exists('/etc/skel/Maildir/'))
    {
        rmdir('/etc/skel/Maildir/');
    }
    
    $updater->configureLxrestart();
    
    echo 'Removing sendmail binaries' . PHP_EOL;
    lunlink("/usr/sbin/sendmail");
    lunlink("/usr/lib/sendmail");
    
    echo 'Creating new sendmail binaries' . PHP_EOL;
    lxfile_cp("../file/linux/qmail-sendmail", "/usr/sbin/sendmail");
    lxfile_cp("../file/linux/qmail-sendmail", "/usr/lib/sendmail");
    lxfile_unix_chmod("/usr/lib/sendmail", "0755");
    lxfile_unix_chmod("/usr/sbin/sendmail", "0755");
    
    echo 'Creating lxredirecter.sh' . PHP_EOL;
    system("cp ../file/linux/lxredirecter.sh /usr/bin/");
    system("chmod 755 /usr/bin/lxredirecter.sh");
    
    if (!lxfile_exists("/usr/bin/php-cgi"))
    {
        lxfile_cp("/usr/bin/php", "/usr/bin/php-cgi");
    }
    
    if (!lxfile_exists("/usr/local/bin/php"))
    {
        lxfile_symlink("/usr/bin/php", "/usr/local/bin/php");
    }
    
    if (lxfile_exists('kloxo.sql'))
    {
        echo 'Removing kloxo.sql' . PHP_EOL;
        lunlink('kloxo.sql');
    }
    
    //remove_lighttpd_error_log
    $f = '/home/kloxo/httpd/lighttpd/error.log';
    
    if(file_exists($f))
    {
        $s = lxfile_size($f);
        if ($s > 50 * 1024 * 1024) {
            lunlink($f);
            createRestartFile("lighttpd");
        }
    }
    
    call_with_flag("fix_secure_log");
    
    installInstallApp();
    
    if (!lxfile_exists("/etc/pure-ftpd/pureftpd.pdb"))
    {
        lxfile_touch("/etc/pure-ftpd/pureftpd.passwd");
        lxshell_return('pure-pw', 'mkdb');
    }
    
    if(file_exists('/etc/init.d/gpm')) // @todo Unknown reason for perform this. Need research
    {
        echo 'Disabling gpm service at boot' . PHP_EOL;
        system('chkconfig gpm off');
    }
    
    echo 'Removing phpinfo.php' . PHP_EOL;
    lxfile_rm('phpinfo.php');
    
    echo 'Creating kloxo.named.conf' . PHP_EOL;
    lxfile_touch('/var/named/chroot/etc/kloxo.named.conf');
    
    echo 'Creating /var/named/chroot/etc/global.options.named.conf' . PHP_EOL;
    lxfile_touch("/var/named/chroot/etc/global.options.named.conf");
    
    echo 'Killing process gettraffic' . PHP_EOL;
    lxshell_return('pkill', '-f', 'gettraffic');
    
    install_if_package_not_exist('maildrop-toaster');
	install_if_package_not_exist('spamdyke');
	install_if_package_not_exist('spamdyke-utils');
	install_if_package_not_exist('pure-ftpd');
	install_if_package_not_exist('simscan-toaster');
	install_if_package_not_exist('webalizer');
	install_if_package_not_exist('php-mcrypt');
	install_if_package_not_exist('dos2unix');
	install_if_package_not_exist('rrdtool');
	install_if_package_not_exist('xinetd');
	install_if_package_not_exist('lxjailshell');
	install_if_package_not_exist('php-xml');
	install_if_package_not_exist('lxphp'); // @todo here someone put libmhash seems deprecated and not needed?

	if (trim(lfile_get_contents("/var/qmail/control/me")) === "core.lxlabs.com") {
		system("echo `hostname` > /var/qmail/control/me");
		createRestartFile("qmail");
	}

	if (trim(lfile_get_contents("/var/qmail/control/me")) === "test.lxlabs.com") {
		system("echo `hostname` > /var/qmail/control/me");
		createRestartFile("qmail");
	}

	copy_script();
	install_xcache();

	lxfile_unix_chmod("/etc/init.d/kloxo", "0755");
	system("chkconfig kloxo on");
	
	addLineIfNotExistInside('/etc/shells', '/usr/bin/lxjailshell', '');
	lxfile_cp("htmllib/filecore/execzsh.sh", "/usr/bin/execzsh.sh");
	lxfile_unix_chmod("/usr/bin/execzsh.sh", "0755");
	
	echo 'Writing permissions on /home' . PHP_EOL;
	lxfile_unix_chmod('/home', '0755');

	echo 'Checking if CentOS 5 version present' . PHP_EOL;
	if (is_centosfive()) 
	{
	    echo 'Detected CentOS 5' . PHP_EOL;
		lxshell_return("sh", "../pscript/centos5-postpostupgrade");
		lxfile_cp("../file/centos-5/CentOS-Base.repo", "/etc/yum.repos.d/CentOS-Base.repo");
		lxfile_rm("/etc/yum.repos.d/epel.repo");
	}

	fix_rhn_sources_file();
	echo 'Symlink lxphp.exe' . PHP_EOL;
	lxfile_symlink("__path_php_path", "/usr/bin/lxphp.exe");
	
	echo 'Coping apache branded conf' . PHP_EOL;
	lxfile_cp("../file/apache/kloxo.conf", "/etc/httpd/conf/kloxo/kloxo.conf"); // @deprecate this
	lxfile_cp("../file/apache/qpanel.conf", "/etc/httpd/conf/kloxo/qpanel.conf");
	lxfile_cp("../file/apache/qpanel.conf", "/etc/httpd/conf/qpanel/qpanel.conf");
	
	echo 'Coping default ssl conf' . PHP_EOL;
	lxfile_cp('../file/apache/default_ssl.conf', '/etc/httpd/conf.d/ssl.conf');
	
	echo 'Coping webmail_redirect conf' . PHP_EOL;
	lxfile_touch("/etc/httpd/conf/kloxo/webmail_redirect.conf");
	
	echo 'Coping ssl conf' . PHP_EOL;
	lxfile_touch("/etc/httpd/conf/kloxo/ssl.conf");
	
	echo 'Coping default conf' . PHP_EOL;
	lxfile_touch("/etc/httpd/conf/kloxo/default.conf");
	
	echo 'Coping cp_config conf' . PHP_EOL;
	lxfile_touch("/etc/httpd/conf/kloxo/cp_config.conf");
	
	if(file_exists('../log/access_log'))
	{
	    echo 'Deleting access_log' . PHP_EOL;
	    lunlink('../log/access_log');
	}
	
	if(file_exists('../log/lighttpd_error.log'))
	{
	    echo 'Deleting lighttpd_error.log' . PHP_EOL;
	    lunlink('../log/lighttpd_error.log');
	}

	@lxfile_rm("/etc/init.d/pure-ftpd");

	if (!lxfile_exists("/etc/xinetd.d/pureftp")) 
	{
		lxfile_cp("../file/xinetd.pureftp", "/etc/xinetd.d/pureftp");
	}

	if(!lxfile_real("/etc/pki/pure-ftpd/pure-ftpd.pem")) 
	{
		lxfile_mkdir("/etc/pki/pure-ftpd/");
		lxfile_cp("../file/program.pem", "/etc/pki/pure-ftpd/pure-ftpd.pem");
	}

	if (!lxfile_exists("/etc/xinetd.d/smtp_lxa")) 
	{
		lxfile_cp("../file/xinetd.smtp_lxa", "/etc/xinetd.d/smtp_lxa");
	}
	
	@lxfile_rm("/etc/xinetd.d/pure-ftpd");
	lxfile_cp("../file/qmail.init", "/etc/init.d/qmail");
	lxfile_unix_chmod("/etc/init.d/qmail", "0755");
	lxfile_cp("../file/lxrestricted", "/etc/lxrestricted");
	lxfile_cp("../file/sysconfig_spamassassin", "/etc/sysconfig/spamassassin");

	lxfile_cp('/var/qmail/control/me', '/var/qmail/control/defaultdomain');
	lxfile_cp('/var/qmail/control/me', '/var/qmail/control/defaulthost');
	$name = trim(lfile_get_contents('/var/qmail/control/me'));
	lfile_put_contents('/var/qmail/control/smtpgreeting', "$name - Welcome to Qmail");

	if (!lxfile_exists('/usr/bin/rblsmtpd')) {
		lxshell_return("ln", "-s", "/usr/local/bin/rblsmtpd", "/usr/bin/");
	}
	if (!lxfile_exists('/usr/bin/tcpserver')) {
		lxshell_return("ln", "-s", "/usr/local/bin/tcpserver", "/usr/bin/");
	}

	call_with_flag("enable_xinetd");
	
	$updater->setLxsuexec();
	$updater->setLxexec();
	$updater->setLxphpsu();

	call_with_flag("restart_xinetd_for_pureftp");

	if (!lxfile_exists("/usr/bin/php-cgi")) 
	{
		echo 'Creating a php-cgi binary' . PHP_EOL;
		lxfile_cp("/usr/bin/php", "/usr/bin/php-cgi");
	}
	
	echo 'Setting permissions php-cgi' . PHP_EOL;
	lxfile_unix_chmod("/usr/bin/php-cgi", "0755");
	
	echo 'Setting permissions closeallinput' . PHP_EOL;
	lxfile_unix_chmod("../cexe/closeallinput", "0755");
	
	system("chown -R apache:apache /home/kloxo/httpd/lighttpd/");
	
	echo 'Setting permissions on php session directory' . PHP_EOL;
	system("chmod 777 /var/lib/php/session/");
	system("chmod o+t /var/lib/php/session/");
	
	echo 'Setting permissions on bogofilter' . PHP_EOL;
	system("chmod 777 /var/bogofilter/");
	system("chmod o+t /var/bogofilter/");
	
	echo 'Killing sisinfoc process' . PHP_EOL;
	system("pkill -f sisinfoc");

	echo 'Installing lighttpd config' . PHP_EOL;
	lxfile_cp('../file/lighttpd/lighttpd.conf', '/etc/lighttpd/lighttpd.conf');
	
	echo 'Installing kloxo lighttpd config' . PHP_EOL;
	lxfile_cp('../file/lighttpd/conf/kloxo/kloxo.conf', '/etc/lighttpd/conf/kloxo/kloxo.conf');
	
	echo 'Installing webmail lighttpd config' . PHP_EOL;
	lxfile_touch('/etc/lighttpd/conf/kloxo/webmail_redirect.conf');

	if (!lxfile_real('/etc/lighttpd/local.lighttpd.conf')) 
	{
		echo 'Emptying local.lighttpd.conf' . PHP_EOL;
		system("echo > /etc/lighttpd/local.lighttpd.conf");
	}
	if (!lxfile_real("/etc/lighttpd/conf/kloxo/webmail_redirect.conf")) {
		system("echo > /etc/lighttpd/conf/kloxo/webmail_redirect.conf");
	}
	if (!lxfile_real("/etc/lighttpd/conf/kloxo/virtualhost.conf")) {
		system("echo > /etc/lighttpd/conf/kloxo/virtualhost.conf");
	}
	if (!lxfile_real("/etc/lighttpd/conf/kloxo/domainip.conf")) {
		system("echo > /etc/lighttpd/conf/kloxo/domainip.conf");
	}

	if (!lxfile_real("/etc/lighttpd/conf/kloxo/ssl.conf")) 
	{
		system("echo > /etc/lighttpd/conf/kloxo/ssl.conf");
	}

	if (!lxfile_real("/etc/lighttpd/conf/kloxo/mimetype.conf")) 
	{
		system("echo > /etc/lighttpd/conf/kloxo/mimetype.conf");
	}
	
	lxfile_touch('/etc/httpd/conf/kloxo/domainip.conf');
	lxfile_touch('/etc/httpd/conf/kloxo/mimetype.conf');

	lxfile_cp('../file/lighttpd/etc_init.d', '/etc/init.d/lighttpd');

	if (!lxfile_exists('/etc/pure-ftpd/pureftpd.passwd')) 
	{
		echo 'Creating new pureftp password' . PHP_EOL;
		
		lxfile_cp("/etc/pureftpd.passwd", "/etc/pure-ftpd/pureftpd.passwd");
		lxshell_return("pure-pw", "mkdb");
		createRestartFile("xinetd");
	}

	if (!lxfile_exists('../etc/flag/xcache_enabled.flg')) 
	{
		if(lxfile_exists('/etc/php.d/xcache.ini'))
		{
			lunlink("/etc/php.d/xcache.ini");
		}
	}

	system("chmod 666 /dev/null");
	@ exec("chkconfig pure-ftpd off 2>/dev/null");

	echo 'Creating nobody suexec user ...' . PHP_EOL;
	$uid = os_get_uid_from_user("lxlabs");
	$gid = os_get_gid_from_user("lxlabs");
	
	$string = "#!/bin/sh\n";
	$string .= "export MUID=$uid\n";
	$string .= "export GID=$gid\n";
	$string .= "export TARGET=/usr/bin/php-cgi\n";
	$string .= "export NON_RESIDENT=1\n";
	$string .= "exec lxsuexec $*\n";
	
	lfile_put_contents("/home/httpd/nobody.sh", $string);
	lxfile_unix_chmod("/home/httpd/nobody.sh", "0755");

	// @todo This seems to create a lxpopuser if not exist. Move this to a php function
	echo 'Checking lxpopuser' . PHP_EOL;
	system("sh ../bin/misc/lxpopuser.sh");

	installRoundCube();
	
	installChooser();
	
	$sgbl = new Sgbl();
	
	if(file_exists($sgbl->getHomeRoot() . '/httpd/script/'))
	{
	    echo 'Removing script directory content' . PHP_EOL;
	    lxfile_rm_content($sgbl->getHomeRoot() . '/httpd/script/');
	}
	
	echo 'Creating script directory' . PHP_EOL;
	lxfile_mkdir("/home/kloxo/httpd/script");
	lxfile_unix_chown_rec("/home/kloxo/httpd/script", "lxlabs:lxlabs");
	
	echo 'Creating phpinfo file' . PHP_EOL;
	lxfile_cp("../file/script/phpinfo.phps", "/home/kloxo/httpd/script/phpinfo.php");
	
	echo 'Coping djbdns init file' . PHP_EOL;
	lxfile_cp("../file/djbdns.init", "/etc/init.d/djbdns");
	
	removeOtherDriver();
	
	if(file_exists($sgbl->getRoot() . '/cache'))
	{
	    echo 'Emptying the cache' . PHP_EOL;
	    lxfile_rm_rec($sgbl->getRoot() . '/cache');
	}
	
	echo 'Creating restart syslog file' . PHP_EOL;
	
	createRestartFile('syslog');
	lxfile_mkdir('/home/kloxo/httpd/awstats/dirdata');

	if (lxfile_exists("/etc/httpd/conf/httpd.conf")) 
	{
		addLineIfNotExistInside("/etc/httpd/conf/httpd.conf", "Include /etc/httpd/conf/kloxo/kloxo.conf", "");
	}
	
	# Issue #450
	if (lxfile_exists("/proc/user_beancounters")) 
	{
	    // Create dev
	    if (lxfile_exists("/sbin/udevd")) 
	    {
		    lxfile_mv("/sbin/udevd", "/sbin/udevd.back");
	    }
	    
    	lxshell_return('tar', '-C', '/dev', '-xzf', '../file/centos-5/vps-dev.tgz');
    	lxshell_return('/sbin/MAKEDEV', 'pty');
    	lxshell_return('/sbin/MAKEDEV', 'tty');
    	lxshell_return('/sbin/MAKEDEV', 'loop');
    	lxshell_return('/sbin/MAKEDEV', 'random');
    	lxshell_return('/sbin/MAKEDEV', 'urandom');
	    lxfile_cp("../file/openvz/inittab", "/etc/inittab");
	} 
	else 
	{
	    if (!lxfile_exists("/sbin/udevd")) 
	    {
			lxfile_mv("/sbin/udevd.back", "/sbin/udevd");
	    }
	}

    $updater->prepareDefaultDir();
}

echo 'Creating start_vps_flag' . PHP_EOL;
lxfile_touch('__path_program_start_vps_flag');

echo 'Create lowmem config' . PHP_EOL;
os_createLowMem();

echo 'Securing webmail mysql' . PHP_EOL;
system('/usr/local/lxlabs/ext/php/php /usr/local/lxlabs/kloxo/bin/misc/secure-webmail-mysql.phps');
echo 'Removing script webmail mysql' . PHP_EOL;
system('/bin/rm /usr/local/lxlabs/kloxo/bin/misc/secure-webmail-mysql.phps');

echo 'Doing the centos5-postupgrade' . "\n";
if(file_exists('/script/centos5-postpostupgrade'))
{
    system('/script/centos5-postpostupgrade');
}
else
{
    echo 'Error: could not find for execute centos5-postpostupgrade script' . PHP_EOL;
    exit(1);
}
die();