<?php
function createServerName($admin_pass = NULL)
{
    $production_server = new pserver(null, 'localhost', 'localhost');
    $production_server->initThisDef();
    $production_server->rolelist = array('web', 'ns');
    
    if(if_demo())
    {
        $production_server->realpass = 'admin';
        $production_server->password = crypt('admin');
        $production_server->cpstatus = 'on';
    }
    else 
    {
    	$production_server->realpass = $admin_pass;
    	$production_server->password = crypt($admin_pass);
    	$production_server->cpstatus = 'on';
    }
    
    $production_server->dbaction = 'add';
    $production_server->postAdd();
    $production_server->superPostAdd();
    $production_server->was();
}

function createDefaultDomainTemplate($dns)
{
    global $gbl, $sgbl, $login, $ghtml; 

    $template = new Domaintemplate(null, null, 'test');
    $template->initThisDef();
    $template->dbaction = 'add';
    $template->ipaddress = $dns->webipaddress;
    $lispriv = new Listpriv(null, null, 'test');
    $listpriv->webpserver_sing = 'localhost';
    $listpriv->mmailpserver_sing = 'localhost';
    $listpriv->dnspserver_sing = 'localhost';
    $listpriv->secdnspserver_sing = '--Disabled--';
    $template->listpriv = $listpriv;
    $template->dnstemplate = $dns->nname;
    // The listpriv used to get to initialized here....
    $template->parent_clname = 'client-admin';
    $template->description = 'The Default Template created Only in debug Mode';
    $template->write();
}

function createDnsTemplate()
{
    global $gbl, $sgbl, $login, $ghtml; 
    if ($sgbl->getDebugLevel() < 1) return;

    $ip = getOneIPForLocalhost('something');
    $dns_template = new DnsTemplate(null, null, 'test');
    $dns_template->nameserver_f = 'ns1.quijost.com';
    $dns_template->webipaddress = $ip;
    $dns_template->mmailipaddress = $ip;
    $dns_template->parent_clname = $login->getClName();
    $dns_template->shared = 'on';
    $dns_template->dbaction = 'add';
    $dns_template->postAdd();
    $dns_template->was();
    createDefaultDomainTemplate($dns_template);
}

/**
 * Create the main admin user at beginning.
 * Enter description here ...
 * @param unknown_type $pass
 */
function add_admin($pass)
{
    global $gbl, $sgbl, $login, $ghtml;

    $client = new Client(null, null, 'admin');
    $login = $client;
    $client->initThisDef();
    $client->priv->pserver_num = 10;
    $client->priv->maindomain_num = 999; // Harcoded limit for domains?
    $client->priv->vps_num = '5';
    $client->priv->client_num = 'Unlimited';
    $client->ddate = time();

    $database = new Sqlite(null, 'client');

    if (!$database->existInTable('nname', 'admin'))
    {
        if ($sgbl->getDebugLevel() > 0)
        {
            $pass = 'lxlabs';
            $res['contacemail'] = 'soporte@quijost.com';
        }
        
        // Set default 'admin' pass on first installation
        if(empty($pass)) 
        {
            $pass = 'admin';
        }
        
        $res['password'] = crypt($pass);
        $res['cttype'] = 'admin';
        $res['cpstatus'] = 'on';

        if(if_demo())
        {
            $res['email'] = 'soporte@quijost.com';
        }
         
        $client->create($res);
        $client->driverApp = new client__sync(null, null, 'admin');
        $client->was();
        lxfile_mkdir('__path_client_root/' . $client->nname);
        lxfile_generic_chown("__path_client_root/$client->nname", 'lxlabs');
    }

    $notif = new Notification(null, null, $client->getClName());
    $notif->initThisDef();
    $notif->dbaction = 'add';
    $notif->text_newaccountmessage = lfile_get_contents('__path_program_root/file/welcome.txt');
    $notif->parent_clname = $client->getClName();
    $notif->write();

    $display = new sp_SpecialPlay(null, null, $client->getClName());
    $display->initThisDef();
    $display->parent_clname = $client->getClName();
    $display->dbaction = 'add';
    $display->write();
}

function init_main($admin_pass)
{
    global $gbl, $sgbl, $login, $ghtml; 

    try
    {
        add_admin($admin_pass);
        initProgram('admin');

        createServerName($admin_pass);
        //createDefaultDomainTemplate();

        $login->was();
        createDnsTemplate();
        Ticket::createWelcomeTicket();
        /*
        if (lxfile_exists("__path_program_etc/license.txt")) {
            decodeAndStoreLicense();
            $login->license_o->write();
            $login->write();
        }
    */
    }
    catch (Exception $e)
    {
        echo $e->getMessage() . "\\n\n\n\n\n\n\n\n\n\nn\n";
    }
    echo "\n";
}