<?php 

include_once ('htmllib/lib/include.php'); 

function installapp_update_main()
{
	echo 'Installapp update main' . PHP_EOL;
    // check/install/update installapp applications
    if(lxfile_exists('/home/kloxo/httpd/installapp') ||
       lxfile_exists('/home/kloxo/httpd/remote-installapp')) 
        application_update();

    installapp_data_update(); # check/install/update installapp data
}

function update_remote_application($appname)
{
	echo 'Running update remote application' . PHP_EOL;
	
    if(empty($appname)) return;
    
    if(lxfile_exists('/tmp/' . $appname . '.zip')) lxfile_rm('/tmp/' . $appname . '.zip');
        
    system('cd /tmp; wget -q http://download.quijost.com/download/installapp/' . $appname . '.zip');
    
    if(!lxfile_real("/tmp/$appname.zip"))
    { 
        print("Could not download $appname\n");
        return; 
    }
    $app = '/home/kloxo/httpd/remote-installapp/' . $appname . '.zip';
    lxfile_rm($app);
    lxfile_mv("/tmp/$appname.zip", $app);
    print("Download Done\n");
}

function do_update_application($appname)
{
	echo 'Running do_update_application' . PHP_EOL;
	
    if (!$appname) { return; }
    if (lxfile_exists("/tmp/".$appname.".zip")) {
    lxfile_rm("/tmp/".$appname.".zip");
    }
    system("cd /tmp ;  wget -q http://download.quijost.com/download/installapp/".$appname.".zip");
    if (!lxfile_real("/tmp/".$appname.".zip")) { 
        print("Could not download $appname\n");
        return; 
    }
    lxfile_rm_rec("/home/kloxo/httpd/installapp/$appname");
    system("cd /home/kloxo/httpd/installapp ; unzip -qq /tmp/".$appname.".zip");
    lxfile_rm("/tmp/".$appname.".zip");
    print("Download Done\n");
}

function update_application($appname)
{
	echo 'Running update_application' . PHP_EOL;
	
    if(lxfile_exists('/home/kloxo/httpd/remote-installapp/'))
        update_remote_application($appname);
    else do_update_application($appname);
}

function application_update()
{
    global $gbl;

    echo 'Running application_update' . PHP_EOL;
    
	$checkflag = $gbl->getObject('general')->generalmisc_b;
	if($checkflag->isOn('disableinstallapp'))
	{
		print('InstallApp is disabled.\n');
		exit;
	}

    print(fill_string('Fetch current InstallApp version', 50));
    $string = file_get_contents('http://download.quijost.com/download/installapp/version.list');
    $rmt = unserialize($string);

    if(!$rmt) throw new lxexception(' could_not_get_application_version_list', '', '');
   
    print(' OK ');
    $remver = $rmt->applist['installapp'];
    echo 'version is ' . $remver . '\n';

    print(fill_string('Fetch local InstallApp version', 50));
    $loc = get_local_application_version_list();
    $locver = $loc->applist['installapp'];
	echo ' OK version is ' . $locver . '\n';

    $updatelist = null;
    $notexisting = null;
    foreach($rmt->applist as $k => $v)
    {
        if ($k === 'installapp') { continue; }

        if (lxfile_exists('/home/kloxo/httpd/remote-installapp') &&
           !lxfile_exists('/home/kloxo/httpd/remote-installapp/' . $k .'.zip'))
        {
			$notexisting[$k] = true;
			continue;
        }
        elseif(!lxfile_exists('/home/kloxo/httpd/installapp/' . $k))
        {
			$notexisting[$k] = true;
			continue;
        }
        
        if (app_version_cmp($loc->applist[$k], $v) === -1)
        {
            $updatelist[$k] = $v;
            continue;
        }

        print(fill_string('Checking application ' .$k, 50) . ' ');
        print('Is latest version ' . $v . '\n');
    }

    foreach((array) $updatelist as $k => $v)
    {
        $string = "Updating application $k";
        $string = fill_string($string, 50);
        print("$string From {$loc->applist[$k]} to $v");
        update_application($k);
    }

    foreach((array) $notexisting as $k => $v)
    {
        echo fill_string('Downloading new application ' . $k, 50);
        update_application($k);
    }
}

installapp_update_main();