<?php 
// This file update all the program when /script/update is runned.
include_once 'htmllib/lib/include.php';
include_once 'lib/updatelib.php';

function do_upgrade($upversion)
{
    global $gbl, $sgbl, $login, $ghtml;
    $maj = $sgbl->__ver_major;
    $program = $sgbl->getProductName();

    $programfile = "$program-" . $upversion . ".zip";

    lxfile_rm_rec($sgbl->getHTMLBase() . '/help');
    lxfile_mkdir("help");
    lxfile_rm_rec($sgbl->getHTMLBase() . '/htmllib/script');
    lxfile_rm_rec("__path_program_root/pscript");

    if (file_exists(".svn"))
    {
        print("SVN exists... Development system.. Not upgrading...\n");
        exit;
    }

    $saveddir = getcwd();
    lxfile_rm_rec($sgbl->getHTMLBase() . '/download');
    lxfile_mkdir("download");
    chdir("download");

    print("Downloading $programfile ...\n");
    download_source("/$program/$programfile");

    print("Download done....\n");
    $host = `hostname`;
    $host = trim($host);
    //  lxshell_unzip("__system__", "../..", $programfile);
    system("cd ../../ ; unzip -o httpdocs/download/$programfile");
    chdir($saveddir);
}

function findNextVersion($lastversion = null)
{
    global $gbl, $sgbl, $login, $ghtml;
    $maj = $sgbl->__ver_major;
    $thisversion = $sgbl->__ver_major_minor_release;

    $upgrade = null;
    $nlist = getVersionList($lastversion);
    dprintr($nlist);
    $k = 0;
    foreach($nlist as $l) {
        if (version_cmp($thisversion, $l) === -1) {
            $upgrade = $l;
            break;
        }
        $k++;
    }
    if (!$upgrade) {
        return 0;
    }

    print("Upgrading from $thisversion to $upgrade\n");
    return $upgrade;

}

function update_all_slave()
{
    $database = new Sqlite(NULL, 'pserver');

    $slaves = $database->getTable(array('nname'));

    foreach($slaves as $slave)
    {
        $slave_name = $slave['nname'];
         
        // Skip the current slave
        if ($slave_name === 'localhost')
        {
            continue;
        }

        try
        {
            echo 'Upgrading Slave ' . $slave_name . ' ...' . PHP_EOL;
            rl_exec_get(NULL, $slave_name, 'remotetestfunc', null);
        }
        catch(Exception $e)
        {
            echo $e->getMessage() . PHP_EOL;
        }
    }
}

exit_if_not_system_user();
exit_if_another_instance_running();

debug_for_backend();
$program = $sgbl->getProductName();
$login = new Client(null, null, 'upgrade');

$opt = parse_opt($argv);

print("Getting Version Info from the Server...\n");
if((isset($opt['till-version']) && $opt['till-version']) || lxfile_exists("__path_slave_db"))
{
    $sgbl->slave = true;
    $upversion = findNextVersion($opt['till-version']);
    $type = 'slave';
}
else
{
    $sgbl->slave = false;
    $upversion = findNextVersion();
    $type = 'master';
}

print("Connecting Quijost download server...\nPlease wait....\n");

if ($upversion)
{
    //do_upgrade($upversion);
    print("Upgrade Done (Disabled).\nCleanup....\n");
    flush();
}
else
{
    print("$program is the latest version\n");
}


if (is_running_secondary())
{
    print("Not running Update Cleanup, because this is running secondary \n");
    exit;
}

echo 'Coping php.ini (disabled)' . PHP_EOL;
//lxfile_cp("htmllib/filecore/php.ini", "/usr/local/lxlabs/ext/php/etc/php.ini");

echo 'Running update cleanup script (disabled)' . PHP_EOL;

//$res = pcntl_exec('/usr/local/lxlabs/ext/php/php', array('../bin/common/tmpupdatecleanup.php', "--type=$type"));

$updater = new Updater();
$updater->configureLxrestart();

echo 'Ready.' . PHP_EOL;