<?php 

class cron__Linux extends lxDriverClass 
{
	function dbactionAdd()
	{
		$this->syncCreateConf();
		$result = array('__syncv_jobid' => $this->main->nname);
	
		return $result;
	}

	function dbactionDelete()
	{
		$this->syncCreateConf();
	}

	function dbactionUpdate($subaction)
	{
		$this->syncCreateConf();
	}

	function getCronString($list)
	{
		if (!is_array($list)) {
			return $list;
		}
		if ($list[0] === '--all--') {
			return "*";
		} else {
			return implode(",", $list);
		}
	}

	function syncCreateConf()
	{
		global $gbl, $sgbl, $login, $ghtml; 
		global $global_shell_error;
		
		// Disable cron on demo
		if_demo_throw_exception('cron');
		
		// @todo check if isset $this->main->username
		$user_name = $this->main->username;
		
		$list = array('minute', 'hour', 'weekday', 'ddate', 'month');
	
		$cmd = NULL;
	
		// Check if the mailto is configured
		$mailto = isset($this->main->__var_mailto) ? $this->main->__var_mailto : NULL;
		
		if(!empty($mailto)) 
		{
			$cmd .= 'MAILTO=' . $mailto . PHP_EOL;
		}
		else 
		{
			$cmd .= 'MAILTO=""' . PHP_EOL;
		}
	
		// Get the cron list and init as array() if no isset or empty
		$cron_list =  isset($this->main->__var_cron_list) ? $this->main->__var_cron_list : array();
		
		$result = empty($cron_list) ? array() : $cron_list;
	
		foreach($result as &$__r) 
		{
			foreach($list as $line) 
			{
				$__r[$line] = unserialize(base64_decode($__r['ser_' . $line]));
			}
		}
	
		$result = merge_array_object_not_deleted($result, $this->main);
	
		//dprintr($result);
	
		foreach((array) $result as $v) 
		{
			$type = $v['ttype'];
			
			if ($type === 'simple') 
			{
				$v['weekday'] = array('--all--');
				$v['month']   = array('--all--');
				$v['ddate']   = array('--all--');
				
				$simple_cron = $v['simple_cron'];
				switch($simple_cron)
				{
					case 'every-day':
						$v['hour']   = $v['cron_day_hour'];
						$v['minute'] = 0;
					break;
					case 'every-hour':
						$v['hour']   = array('--all--');
						$v['minute'] = 0;
					break;
					case 'every-minute':
						$v['hour']   = array('--all--');
						$v['minute'] = array('--all--');
					break;
				}
			} 
			else 
			{
				foreach($v['weekday'] as &$___tq)  
				{
					if (is_numeric($___tq)) 
					{
						$___tq -= 1;
					}
				}
			}
	
			foreach($list as $line) 
			{
				$v[$line] = $this->getCronString($v[$line]);
			}
	
			if (!$v['minute']) 
			{ 
				$v['minute'] = 0; 
			}
	
			$data = array($v['minute'], $v['hour'], $v['ddate'], $v['month'],$v['weekday'], $v['command']);
			$cmd .= implode('\t', $data) . PHP_EOL;
		}
	
		// Check if the cron user exist
		if (!posix_getpwnam($user_name)) 
		{
			lxfile_rm('/var/spool/cron/' . $user_name);
			return;
		}
		
		// Create a temporal file for write the cron command
		$conf_file = '__path_cron_root/' . $user_name;
		$cron_file = lx_tmp_file($conf_file);
		
		lfile_put_contents($cron_file, $cmd);
	
		// Create the cron task
		$ret = lxshell_return('crontab', '-u', $user_name, $cron_file);
	
		if ($ret) 
		{
			// Why exactly was a throw removed? backup/restore?
			//throw new lxException("adding_cron_failed", "", $global_shell_error);
			$gbl->setWarning('adding_cron_failed', '', $global_shell_error);
			$data = lfile_get_contents($tfile);
			log_log('cron_error', $data);
		}
	
		lunlink($tfile);
	}
}