<?php 
require_once 'htmllib/lib/driverlib.php';

class Gbllib extends Lxclass
{ # GloBLals lib
    function write(){}
    function get(){ }

    function __construct()
    {
        $this->nname = 'gbl';

        $this->__fvar_dont_redirect = null;
        $this->setCurrentSession(NULL);
        $this->__this_warning       = null;
    }
    
    public function getCurrentSession()
    {
    	return $this->c_session;
    }
    
    public function setCurrentSession($current_session)
    {
    	$this->c_session = $current_session;
    }

    function setWarning($message, $var, $val)
    {
        $this->__this_warning['message'] = $message;
        $this->__this_warning['var']     = $var;
        $this->__this_warning['val']     = $val;
    }

    function getClass()
    {
        return 'gbl';
    }

    function __get($var)
    {
        return false;
    }

    function loaddriverappInfo($master)
    {
        $db = new Sqlite($master, 'driver');
        $res = $db->getTable();

        // Doing the setFromArray stuff here itself. Since that is the place from where we are called, and if we call setfromarray here, naturally it results in a loop.
        $__t_ob = null;
        foreach((array) $res as $row)
        { 
            $nname = $row['nname'];
            $obj = new driver($master, null, $nname);

            if(!empty($row))
            {
                foreach($row as $key => $value)
                {
                    if (csb($key, "ser_"))
                    {
                        $key = strfrom($key, "ser_");
                        $value = unserialize(base64_decode($value));
                    }
    
                    if(cse($key, "_b") && !is_object($value)) $value = new $key(null, null, $nname);
    
                    if(is_numeric($key)) continue;
    
                    $obj->$key = $value;
                }
            }
            else 
            {
                echo 'Warning: empty row on loaddriverappInfo() with master=' . $master. ' and nname='  . $nname . PHP_EOL;
            }
            
            $__t_ob[$nname] = $obj;
        }
        
        if(!isset($this->driver)) $this->driver = array();
       
        $this->driver[$master] = $__t_ob;
        //dprintr($this->driver);
    }

    function getSyncClass($master, $syncserver, $class)
    {
        global $gbl, $sgbl, $login, $ghtml; 

        if (!$login) return;
     
        if (isLocalhost($master)) 
        {
            $master = 'localhost';
        }

        if ($login->isSuperadmin() && $master === 'localhost') return null;

        if (isLocalhost($syncserver)) 
        {
            $syncserver = 'localhost';
        }

        //Dynamically load the syncserver info....
        if (!isset($this->driver) || !isset($this->driver[$master])) 
        {
            $this->loaddriverappInfo($master);
        }
        
        if (!isset($this->driver[$master][$syncserver])) 
        {
            $this->loaddriverappInfo($master);
        }

        $class_var = strtolower("pg_" . $class);
        //debugBacktrace();

        if(isset($this->driver[$master][$syncserver]))
        {
	        $driver = $this->driver[$master][$syncserver];
	        
	        $pgm = $driver->driver_b;
	
	        if (isset($pgm->$class_var))
	        {
	            $str = $pgm->$class_var;
	            if(csb($str, "__v_")) $class_var = "pg_" . strtolower(strfrom($str, "__v_"));
	            
	            return $pgm->$class_var;
	        }
        }
        else 
        {
        	//dprint('Error loading driver \'' . $syncserver . '\' on ' . $master . PHP_EOL);
        }
        return NULL;
    }

    function setHistory()
    {
        global $gbl, $sgbl, $login, $ghtml; 
        $ac = array('addform', 'updateform', 'list', 'show');

        if (!array_search_bool(strtolower($ghtml->__http_vars['frm_action']), $ac)) return;
       
        //$histlist = $this->getSessionV("lx_history_var");

        $histlist = $login->dskhistory;
        $buttonpath = NULL;

        $url = "/display.php?{$ghtml->get_get_from_current_post(array('Search', 'frm_hpfilter'))}";
        $description = $ghtml->getActionDetails($url, null, $buttonpath, $path, $post, $file, $name, $image, $__t_identity);

        if($file === 'ffile') return;
        if($file === 'dskshortcut_a') return;
        if (cse($file, 'installapp')) return;

        unset($histlist[$url]);
        $histlist[$url] = time();

        while(count($histlist) > 20) { array_shift($histlist); }

        //$this->setSessionV("lx_history_var", $histlist);

        $login->dskhistory = $histlist;
        $login->setUpdateSubaction();
        $login->write();
    }

    function setSessionV($key, $value)
    {
    	$current_session = $this->getCurrentSession();
        if (!isset($current_session)) 
        {
            //throw new lxexception ("Current Session Not Set");
            return 0;
        }
		
        if ($current_session->dbaction === "delete") return;
        
        if (!isset($current_session->ssession_vars)) 
        {
            $current_session->ssession_vars = NULL;
        }
        
        $current_session->ssession_vars[$key] = $value;
        $current_session->setUpdateSubaction();
    }

    function isetSessionV($key)
    {
        return isset($this->getCurrentSession()->ssession_vars[$key]);
    }

    function unsetSessionV($key)
    {
        unset($this->getCurrentSession()->ssession_vars[$key]);
        $this->getCurrentSession()->dbaction = 'update';
    }

    function getSessionV($key)
    {
    	$current_session = $this->getCurrentSession(); 
        return (isset($current_session->ssession_vars[$key])) ? $current_session->ssession_vars[$key] : NULL;
    }

    function isOn($var)
    {
        return (strtolower($this->getSessionV($var)) === 'on');
    }

    final function getHttpReferer()
    {
        global $gbl, $sgbl, $login, $ghtml; 

        $referer = $this->getSessionV('lx_http_referer');
        $current_query_string = $ghtml->get_get_from_post(array(), $ghtml->__http_vars);
        $cur_url = $_SERVER['PHP_SELF'] . '?' . $current_query_string;
        if ($cur_url === $referer) return $this->getSessionV('lx_http_referer_parent');
        return $referer;
    }
}