<?php
# Note: current path for load files is 'httpdocs'
require_once 'exceptions/lxException.php';

require_once 'htmllib/lib/linux/lib.php';

// Don't remove this. This is used for slave upgrade on htmllib/lib/updatelib.php.
function remotetestfunc()
{

}

define('S_IFDIR', 00040000);
define('S_ISUID', 00004000);
define('S_ISGID', 00002000);

require_once 'lib/sgbl.php';

function check_for_debug($file)
{
	/* Check for Development/Debug version
	 If file not exists, Production mode (-1)
	If file exists it can have the following numbers to enable
	1  = Debug mode 1
	2  = Debug mode 2
	3  = Debug mode 3
	4  = Debug mode 4
	5  = Debug mode 5
	-1 = Turn Off and go to production mode */

	global $gbl, $sgbl, $login, $ghtml;

	require_once 'htmllib/lib/commonfslib.php';
	require_once 'htmllib/lib/includecore.php';

	if(!isset($sgbl))
	{
	    $sgbl = new Sgbl();
	}
	
	if(lxfile_exists(getreal($file)))
	{
	    $sgbl->setDebug(intval(lfile_get_contents(getreal($file))));
	}
	else  
	{
	    $sgbl->setDebug($sgbl::PRODUCTION_MODE);
	}
	 
	if($sgbl->isDebug())
	{
		ini_set('error_reporting', E_ALL & ~E_STRICT);
		ini_set('display_errors', 'On');
		ini_set('log_errors', 'On');
	}
	else
	{
		ini_set('error_reporting', E_ERROR);
		ini_set('display_errors', 'Off');
		ini_set('log_errors', 'On');
	}
}

function debug_for_backend()
{
	global $gbl, $sgbl, $login, $ghtml;
	
	check_for_debug('/commands.php');
	
	if($sgbl->isDebug()) 
	{
	    return;
	}
	
	check_for_debug('/backend.php');
}

function isUpdating()
{
	return lx_core_lock_check_only('update.php');
}

function getAllOperatingSystemDetails()
{
	$ret = findOperatingSystem();
	$ret['loadavg'] = os_getLoadAvg();
	dprintr($ret);
	return $ret;
}

function findOperatingSystem($type = null)
{
	if(file_exists('/etc/fedora-release'))
	{
		$data['os'] = 'fedora';
		$data['version'] = file_get_contents('/etc/fedora-release');
		$data['pointversion'] = find_os_pointversion();
	}
	elseif(file_exists('/etc/redhat-release'))
	{
		$data['os'] = 'rhel';
		$data['version'] = file_get_contents('/etc/redhat-release');
		$data['pointversion'] = find_os_pointversion();
	}

	/* [FIXME] Not sure that it is used on qpanel
	 if(lxfile_exists($sgbl->getEtc() . 'install_xen') || lxfile_exists('/proc/xen'))
	{
	$data['vpstype'] = 'xen';
	$data['xenlocation'] = vg_complete();
	}*/

	if($type) return $data[$type];

	return $data;
}

function find_os_pointversion()
{
	if (file_exists("/etc/fedora-release")) {
		$release = trim(file_get_contents("/etc/fedora-release"));
		$osv = explode(" ", $release);
		if (strtolower($osv[1]) === 'core') {
			$osversion = "fedora-" . $osv[3];
		} else {
			$osversion = "fedora-" . $osv[2];
		}
		return $osversion;
	}

	if (file_exists("/etc/redhat-release")) {
		$release = trim(file_get_contents("/etc/redhat-release"));
		$osv = explode(" ", $release);
		if (isset($osv[6])) {
			$osversion = "rhel-" . $osv[6];
		} else {
			$oss = explode(".", $osv[2]);
			$osversion = "centos-" . $oss[0];
		}
		return $osversion;
	}
}

function lscandir_without_dot($arg, $dotflag = false)
{
	$list = lscandir($arg);

	if (!$list) {
		return $list;
	}

	foreach ($list as $k => $v) {
		if ($v === ".." || $v === "." || $v === '.svn') {
			unset($list[$k]);
		}
		if ($dotflag && csb($v, '.')) {
			unset($list[$k]);
		}
	}
	return $list;
}

function lscandir_without_dot_or_underscore($arg, $dotflag = false)
{
	$list = lscandir($arg);

	if (!$list) {
		return $list;
	}

	foreach ($list as $k => $v) {
		if ($v === ".." || $v === "." || $v === '.svn') {
			unset($list[$k]);
		}
		if ($dotflag && csb($v, '.')) {
			unset($list[$k]);
		}
		if (csb($v, "__")) {
			unset($list[$k]);
		}
	}
	return $list;
}

function lscandir($arg)
{
	return lx_redefine_func("scandir", $arg);
}

function lunlink($arg)
{
	return lx_redefine_func("unlink", $arg);
}

function ltouch($arg)
{
	return lx_redefine_func("touch", $arg);
}

function lchdir($arg)
{
	return lx_redefine_func("chdir", $arg);
}

function takeToStartOfLine($fp)
{
	while (fgetc($fp) == "\n" && ftell($fp) != 1 && ftell($fp) != 0) {
		fseek($fp, -2, SEEK_CUR);
	}

	while (($c = fgetc($fp)) != "\n" && ftell($fp) != 1 && ftell($fp) != 0) {
		fseek($fp, -2, SEEK_CUR);
	}
}

function tail_func($file, $lines)
{
	$fp = fopen($file, "r");

	if (!$fp) {
		return null;
	}

	dprint("in Tail Func\n");

	fseek($fp, 0, SEEK_END);

	// Go back onece and read the line.
	takeToStartOfLine($fp);
	$arr[] = fgets($fp);

	$n = 0;
	while ($n < $lines && ftell($fp) !== 1) {
		$n++;
		//dprint($n . "\n");
		// You have to go back twice.
		print(' Before: ' . ftell($fp) . "\n");
		fseek($fp, -3, SEEK_CUR);
		takeToStartOfLine($fp);
		fseek($fp, -3, SEEK_CUR);
		print(' aaFter: ' . ftell($fp) . "\n");
		takeToStartOfLine($fp);
		print(' aaaaFter: ' . ftell($fp) . "\n");
		$arr[] = fgets($fp);
	}
	return implode("", array_reverse($arr));
}

function lfile_get_json_unserialize($file)
{
	if (!lxfile_exists($file)) {
		return null;
	}
	return json_decode(lfile_get_contents($file), true);
}

function lfile_put_json_serialize($file, $var)
{
	return lfile_put_contents($file, json_encode($var));
}

function lfile_get_unserialize($file)
{
	if (!lxfile_exists($file)) {
		return null;
	}
	return unserialize(lfile_get_contents($file));
}

function lfile_put_serialize($file, $var)
{
	return lfile_put_contents($file, serialize($var));
}

function lfile_get_contents($arg)
{
	return lx_redefine_func("file_get_contents", $arg);
}

function lrename($arg1, $arg2)
{
	return lx_redefine_func("rename", $arg1, $arg2);
}

function lfopen($arg1, $arg2)
{
	return lx_redefine_func("fopen", $arg1, $arg2);
}

function lfilesize($arg)
{
	return lx_redefine_func("filesize", $arg);
}

function ltempnam($arg1, $arg2)
{
	return lx_redefine_func("tempnam", $arg1, $arg2);
}

function lfile_write_content($file, $data, $user)
{
	if (csa($user, ":")) {
		$realuser = strtil($user, ":");
	} else {
		$realuser = $user;
	}

	if (!check_file_if_owned_by($file, $realuser)) {
		return;
	}
	lfile_put_contents($file, $data);
	lxfile_unix_chown($file, $user);
}

function check_file_if_owned_by_and_throw($filename, $username)
{
	if (!check_file_if_owned_by($filename, $username)) {
		throw new lxexception('file_exists_not_owned', '', $filename);
	}
}

function lis_hardlink($file)
{
	$file = expand_real_root($file);
	if (is_dir($file)) {
		return false;
	}
	$stat = stat($file);
	if ($stat['nlink'] >= 2) {
		return true;
	}
	return false;
}

function is_soft_or_hardlink($file)
{
	if (!lxfile_exists($file)) {
		return false;
	}

	if (lis_link($file) || lis_hardlink($file)) {
		return true;
	}
	return false;
}

function new_process_mv_rec($user, $src, $dst)
{
	$src = expand_real_root($src);
	$dst = expand_real_root($dst);
	new_process_cmd($user, null, "mv $src $dst");
}

function new_process_chmod_rec($user, $file, $perm)
{
	$file = expand_real_root($file);
	$cmd = "chmod -R $perm '$file'";
	new_process_cmd($user, null, $cmd);
}

function new_process_cp_rec($user, $src, $dst)
{
	$src = expand_real_root($src);
	$dst = expand_real_root($dst);
	$cmd = "cp -a '$src' '$dst'";
	new_process_cmd($user, null, $cmd);
}

function new_process_cmd($user, $dir, $cmd)
{
	global $sgbl;

	if (csa($user, ':')) {
		list($user, $group) = explode(':', $user);
	} else {
		$group = $user;
	}

	if ($user === 'root') {
		$user = '__system__';
	}

	if ($dir) {
		$olddir = getcwd();
		chdir($dir);
	}
	if ($user !== '__system__') {
		$uid = is_numeric($user) ? (int) $user : os_get_uid_from_user($user);
		$gid = is_numeric($group) ? (int) $group : os_get_gid_from_user($user);
		exec("{$sgbl->__path_php_path} {$sgbl->__path_program_root}/bin/phpexec.php $uid $gid $cmd 2>&1", $output, $retval);
	} else {
		exec("$cmd 2>&1", $output, $retval);
	}

	if ($dir) {
		chdir($olddir);
	}

	$output = implode("\n", $output);
	log_log('user_cmd', "($dir) $user $cmd $output");

	return $retval;
}

function lfile_put_contents($file, $data, $flag = null)
{
	$file = expand_real_root($file);

	if (is_soft_or_hardlink($file)) {
		log_log("link_error", "$file is hard or symlink. Not writing\n");
		return;
	}
	 
	if (char_search_a($data, "__path_")) {
		dprint("<font color=red>Warning : Trying to write __path into a file $file: </font> $data <br> \n", 3);
	}

	lxfile_mkdir(dirname($file));

	if(file_exists($file))
	{
		if(is_readable($file))
		{
			if(is_writable($file)){
				$result = file_put_contents($file, $data, $flag);
				chown($file, 'lxlabs');
				return $result;
			}
			else{
				$posix_data = posix_getpwuid(fileowner($file));
				$error_msg = 'Could not write the file \'' . $file . '\' with permissions: ' .
				substr(sprintf('%o', fileperms($file)), -4) .
                ' UID: ' . $posix_data['name'] .  ':' . $posix_data['uid'] .
                ' GID: ' . $posix_data['gecos'] .  ':' . $posix_data['gid'] .
				( PHP_SAPI !== 'cgi-fcgi' ? PHP_EOL : '<br />');

				dprint($error_msg);
				log_log('filesys', $error_msg);
				return false;
			}
		}
		else
		{
			$error_msg = 'Could not read the file \''.$file.'\' with permissions: '.substr(sprintf('%o', fileperms($file)), -4) . ( PHP_SAPI !== 'cgi-fcgi' ? PHP_EOL : '<br />');
			dprint($error_msg);
			log_log('filesys', $error_msg);
			return false;
		}
	}
	else
	{
		$result = file_put_contents($file, $data, $flag);
		chown($file, 'lxlabs');
		 
		if($result === false)
		{
			$error_msg = 'File \''.$file.'\' could not be created.';
			dprint($error_msg);
			//log_log('filesys', $error_msg);
			return false;
		}
		return true;
	}
}

/**
 * @return void
 * @param unknown
 * @param unknown
 * @desc Redefining php functions ... sort of.. Stupid php doesn't allow that. So we do the next best thing.. We add an 'l' to all system functions and then use these functions instead of the php ones... In a way, is a better idea too, since, there might always be some cases where we might want to override this crap. :-)
 */
function lmkdir($dir)
{
	return lx_redefine_func("mkdir", $dir);
}

function lis_executable($file)
{
	return lx_redefine_func("is_executable", $file);
}

function lis_readable($file)
{
	return lx_redefine_func("is_readable", $file);
}

function lreadlink($file)
{
	return lx_redefine_func("readlink", $file);
}

function lis_link($file)
{
	return lx_redefine_func("is_link", $file);
}

function lis_dir($file)
{
	return lx_redefine_func("is_dir", $file);
}

function cp_if_not_exists($src, $dst)
{
	if (lxfile_exists($dst)) {
		return;
	}
	if (!lxfile_exists($src)) {
		return;
	}
	lxfile_cp($src, $dst);
}

function cp_rec_if_not_exists($src, $dst)
{
	if (lxfile_exists($dst)) {
		return;
	}
	if (!lxfile_exists($src)) {
		return;
	}
	lxfile_cp_rec($src, $dst);
}

function mv_rec_if_not_exists($src, $dst)
{
	if (lxfile_exists($dst)) {
		return;
	}
	if (!lxfile_exists($src)) {
		return;
	}
	lxfile_mv_rec($src, $dst);
}

function llstat($file)
{
	return lx_redefine_func("lstat", $file);
}

function lx_merge_good($arg)
{
	global $gbl, $sgbl, $login, $ghtml;

	$arglist = array();
	
	$num_args = @func_num_args();
	for ($i = 0; $i < $num_args; $i++)
	{
	    $arglist[] = func_get_arg($i);
	}

	//dprintr($arglist);

	$list = $arglist;

	foreach ($list as &$l)
	if(!$l) $l = array();


	$ret = array();
	foreach ($list as $nl) {
		//dprintr($nl);
		if (is_array($nl)) {
			$ret = array_merge($ret, $nl);
		} else {
			$ret[] = $nl;
		}
	}
	return $ret;
}

function lx_array_merge($list)
{
	foreach ($list as &$l) {
		if (!$l) {
			$l = array();
		}
	}
	$ret = array();
	foreach ($list as $nl) {
		//dprintr($nl);
		if (is_array($nl)) {
			$ret = array_merge($ret, $nl);
		} else {
			$ret[] = $nl;
		}
	}
	return $ret;
}

function log_switch($mess, $id = 1)
{
	log_log('switch', $mess, $id);
}

function log_error($mess, $id = 1)
{
	log_log('error', $mess, $id);
}

function log_bdatabase($mess, $id = 1)
{
	log_log('bdatabase', $mess, $id);
}

function log_restore($mess, $id = 1)
{
	log_log('restore', $mess, $id);
}

function log_database($mess, $id = 1)
{
	log_log('database', $mess, $id);
}

function myPcntl_reaper()
{
	pcntl_wait($status, WNOHANG);
}

function myPcntl_wait()
{
	pcntl_wait($status);
}

function myPcntl_fork()
{
	global $gbl, $sgbl, $login, $ghtml;

	$pid = pcntl_fork();

	return $pid;
}

function log_log($file, $message, $id = NULL)
{
	if (!is_string($message))
	{
		$message = var_export($message, true);
	}

	$message = trim($message);

	$sgbl = new Sgbl();
	$root_path = $sgbl->getRoot();

	$rf = $root_path . '/log/' . $file;

	lfile_put_contents($rf, @ date('H:i M/d/Y') . ': ' . $message . PHP_EOL, FILE_APPEND);
}

function log_ajax($mess, $id = 1)
{
	log_log('ajax', $mess, $id);
}

function log_redirect($mess, $id = 1)
{
	log_log('redirect_error', $mess, $id);
}

function log_message($mess, $id = 1)
{
	log_log('message', $mess, $id);
}

function log_security($mess, $id = 1)
{
	// get IP
	if (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) {
		$ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
	}
	else {
		$ip = $_SERVER['REMOTE_ADDR'];
	}

	$user_agent = $_SERVER["HTTP_USER_AGENT"];

	if (empty($_SERVER["HTTP_USER_AGENT"])) {
		$user_agent = "Not a browser";
	}

	log_log('security', $mess . " IP: $ip; User agent: $user_agent", $id);
}

function log_filesys_err($mess, $id = 1)
{
	log_log('filesyserr', $mess, $id);
}

function log_filesys($mess, $id = 1)
{
	global $global_dontlogshell;
	if ($global_dontlogshell) {
		log_log('nonfilesys', $mess, $id);
	} else {
		log_log('filesys', $mess, $id);
	}
}

function log_shell($mess, $id = 1)
{
	log_log('shell_exec', $mess, $id);
}

function log_shell_error($mess, $id = 1)
{
	log_log('shell_error', $mess, $id);
}

function lfile_trim($arg)
{
	$list = lfile($arg);
	foreach ($list as &$s) {
		$s = trim($s);
	}
	return $list;
}

function lcopy($src, $dst)
{
	return lx_redefine_func("copy", $src, $dst);
}

function lreadfile($file)
{
	return lx_redefine_func("readfile", $file);
}

function lmd5_file($file)
{
	return lx_redefine_func("md5_file", $file);
}

function lfile_exists($file)
{
	return lx_redefine_func("file_exists", $file);
}

function lsqlite_open($file)
{
	return lx_redefine_func("sqlite_open", $file);
}

/**
 * @return void
 * @param unknown
 * @param unknown
 * @desc This function is the core of the the path abstraction. It converts the paths of the form '__path.../dir' to '$sgbl->__path.../dir'. This is used in all the redefined functions to convert their arguments.
 */
function expand_real_root($root)
{
	global $gbl, $sgbl, $login, $ghtml;
	if (char_search_beg($root, "__path")) {
		if (char_search_a($root, "/")) {
			$var = substr($root, 0, strpos($root, "/"));
			if(!isset($sgbl->$var))
			{
				switch($var)
				{
					default:
						$root = $var;
					dprint('Error: expand_real_root: $var');
					debug_print_backtrace();
					break;
				}
			}
			else $root = ($sgbl->$var) . "/" . substr($root, strpos($root, "/") + 1);
		} else {
			$root = $sgbl->$root;
		}
	}
	$root = remove_extra_slash($root);
	return $root;
}

/**
 * @return void
 * @param unknown
 * @param unknown
 * @desc the function that does the redefining of fundamental file access functions.
 * Note the double use of 'eval'. hey hey, nothing is impossible in php.
 * Never ever repeat the code; Make it unreadable instead. :-)
 */
function kill_and_save_pid($name)
{
	kill_pid($name);
	usleep(50);
	save_pid($name);
}

function save_pid($name)
{
	$pid = os_getpid();
	echo 'Saving PID: ' . $pid . "\n";
	lfile_put_contents("__path_program_root/pid/$name.pid", $pid);
}

function kill_pid($name)
{
	$pid = lfile_get_contents("__path_program_root/pid/$name.pid");
	echo 'Killing process with PID: ' . $pid . "\n";
	os_killpid($pid);
}

function lx_redefine_func($func)
{
	global $gbl, $sgbl, $login, $ghtml;

	$arglist = array();

	$num_args = @func_num_args();
	for ($i = 1; $i < $num_args; $i++)
	{
	    $arglist[] = expand_real_root(func_get_arg($i));
	}

	return call_user_func_array($func, $arglist);
}

function remove_unnecessary_stat(&$stat)
{
	foreach ($stat as $k => $v)
	if(is_numeric($k)) unset($stat[$k]);
}

function getShellCommand($cmd, $arglist)
{
	global $gbl, $sgbl, $login, $ghtml;
	$args = null;
	$q = $sgbl->__var_quote_char;
	$cmd = expand_real_root($cmd);
	$cmd = str_replace(";", "", $cmd);
	$cmd = "{$q}$cmd{$q}";

	foreach ($arglist as $a) {
		if ($a === "") {
			continue;
		}
		if (is_array($a)) {
			foreach ($a as $aa) {
				$aa = str_replace(";", "", $aa);
				$args .= " $q" . expand_real_root($aa) . "$q";
			}
		} else {
			$a = str_replace(";", "", $a);
			$args .= " $q" . expand_real_root($a) . "$q";
		}
	}
	$cmd .= " " . $args;
	return $cmd;
}

class Remote
{
	/*
	 public $ddata;
	public $message;
	public $exception;
	*/
}

function dprintoa($var, $type = 0)
{
	global $sgbl, $login, $ghtml;
	if ($type > $sgbl->getDebugLevel()) return;

	if (!is_array($var)) return;

	foreach ($var as $k => $v)
	{
		dprint("$k =>");
		dprinto($var, $type);
		dprint("\n");
	}
}

function dprinto($var, $type = 0)
{
	global $sgbl;

	if ($type > $sgbl->getDebugLevel()) return;

	if (!is_object($var)) return;

	$newob = clone($var);
	$newob->__parent_o = null;
	dprintr($newob);
}

function dprintr($var, $type = 0)
{
	global $sgbl;

	if ($type > $sgbl->getDebugLevel()) return;

	if (is_object($var) && method_exists($var, "clearChildrenAndParent"))
	{
		$newvar = myclone($var);
		lxclass::clearChildrenAndParent($newvar);
		$newvar->driverApp = 'unset for printing';
		$newvar->__parent_o = 'unset for printing';

		$class = $newvar->get__table();
		if (csb($class, "sp_")) {
			$bclass = strfrom($class, "sp_") . "_b";
			$newvar->$bclass->__parent_o = 'unset for printing';
		}
	}
	else $newvar = $var;

	print_r($newvar);
}

function dprint($var, $type = 0)
{
	global $sgbl;
	if ($type <= $sgbl->getDebugLevel())
	if(is_string($var))
	{
		print($var);
	}
}

function dprint_r($var, $type = 0)
{
	global $sgbl;
	if($type <= $sgbl->getDebugLevel()) print_r($var);
}

function lx_local_socket_read($socket)
{
	return @ socket_read($socket, 2048);
	//$res=socket_recv($MsgSock,$buffer,1024,0);
}

/**
 * char_search_a
 * @param unknown_type $haystack
 * @param unknown_type $needle
 * @param unknown_type $insensitive
 */
function csa($haystack, $needle, $insensitive = 0)
{
	return char_search_a($haystack, $needle, $insensitive);
}

function char_search_a($haystack, $needle, $insensitive = 1)
{
	if (is_array($haystack)) {
		//dprint("Got array in Char Search ");
		//dprintr($haystack);
	}

	if (is_object($haystack)) {
		$v = debugBacktrace(true);
		log_log("error", $v);
	}
	if ($insensitive) {
		return (false !== stristr($haystack, $needle)) ? true : false;
	} else {
		return (false !== strpos($haystack, $needle)) ? true : false;
	}
}

function strtil($string, $needle)
{
	if (strrpos($string, $needle) !== false) {
		return substr($string, 0, strrpos($string, $needle));
	} else {
		return $string;
	}
}

function strtilfirst($string, $needle)
{
	if (strpos($string, $needle)) {
		return substr($string, 0, strpos($string, $needle));
	} else {
		return $string;
	}
}

function strfrom($string, $needle)
{
	if (!csa($string, $needle)) {
		return $string;
	}
	return substr($string, strpos($string, $needle) + strlen($needle));
}

function array_push_unique($array, $value)
{
	if (!$array) {
		$array = array();
	}
	foreach ($array as $var) {
		if ($var === $value) {
			return $array;
		}
	}
	$array[] = $value;
	return $array;
}

function array_remove($array, $element)
{
	$ret = null;
	foreach ($array as $value) {
		if ($value !== $element) {
			$ret[] = $value;
		}
	}
	return $ret;
}

function csb($haystack, $needle, $insensitive = 1)
{
	# Char Search Begin
	return char_search_beg($haystack, $needle);
}

function char_search_beg($haystack, $needle)
{
	if (is_array($haystack)) {
		//debugBacktrace();
	}
	if (strpos($haystack, $needle) === 0) {
		return true;
	}
	return false;
}

function cse($haystack, $needle, $insensitive = 1)
{
	# Char Search End
	return char_search_end($haystack, $needle, $insensitive);
}

function char_search_end($haystack, $needle, $insensitive)
{
	if (strpos($haystack, $needle) === false) {
		return false;
	}

	if ((strrpos($haystack, $needle) + strlen($needle)) === strlen($haystack)) {
		return true;
	} else {
		return false;
	}
}

function array_search_bool($needle, $haystack)
{
	if (!$haystack) {
		return false;
	}
	if (array_search($needle, $haystack) !== false) {
		return true;
	}

	return false;
}

function remove_dot_dot($list)
{
	foreach ($list as $k => $v) {
		if ($v === "." || $v === "..") {
			unset($list[$k]);
		}
	}
	return $list;
}

function lx_tmp_file($file)
{
	global $gbl, $sgbl, $login, $ghtml;
	$file = expand_real_root($file);
	$n = preg_replace("+/+i", "_", $file);
	return tempnam("$sgbl->__path_tmp/", "lxtmp_$n");
	//return "/tmp/" . $n;
}

function lx_array_keys($list)
{
	if (!$list) {
		$list = array();
	}
	return array_keys($list);
}

function array_filter_key($full, $need)
{
	if (!$need) {
		return $full;
	}

	foreach ($full as $key => $value) {
		if (array_search_bool($key, $need)) {
			$ret[$key] = $value;
		}
	}
	return $ret;
}

function gethtmllibversion()
{
}

function isOn($var)
{
	return (($var === 'on') || ($var === 'On')) ? true : false;
}

// Function that is called to test whther the remote server is working fine or not. Used while adding.
function test_remote_func()
{
	return true;
}

function log_clicks($mess, $id = 1)
{
	global $gbl, $sgbl, $login, $ghtml;

	if (!if_demo())
	{
		return;
	}

	$ip = $gbl->getCurrentSession()->ip_address;
	$mess = trim($mess);
	$file = "__path_program_root/log/clicks";
	lfile_put_contents($file, "$id: $ip: " . @date("H:i:s M/d/Y") . ": $mess\n", FILE_APPEND);
}

# Version Comparison Returns 1 if version1 is greater, and -1 if version2 is greater.
function version_cmp($version1, $version2)
{
	$l1 = explode(".", $version1);
	$l2 = explode(".", $version2);

	for ($i = 0; $i < 3; $i++) {
		if ($l2[$i] === $l1[$i]) {
			continue;
		}
		if ($l1[$i] > $l2[$i]) {
			return 1;
		}
		if ($l1[$i] < $l2[$i]) {
			return -1;
		}
	}
}

function app_version_cmp($version1, $version2)
{
	$l1 = explode(".", $version1);
	$l2 = explode(".", $version2);

	for ($i = 0; $i < 4; $i++) {
		if (!isset($l2[$i])) {
			$l2[$i] = 0;
		}
		if (!isset($l1[$i])) {
			$l1[$i] = 0;
		}
	}

	//dprintr($l1);
	//dprintr($l2);

	for ($i = 0; $i < 4; $i++) {
		if ($l2[$i] === $l1[$i]) {
			continue;
		}
		if ($l1[$i] > $l2[$i]) {
			return 1;
		}
		if ($l1[$i] < $l2[$i]) {
			return -1;
		}
	}
}

function fput_content_with_lock($file, $string)
{
	lfile_put_contents($file, $string);
}

function filter_object_list($list, $rule)
{
	$nlist = null;
	foreach ((array) $list as $o) {
		if ($o->eeval($rule)) {
			$nlist[$o->nname] = $o;
		}
	}
	return $nlist;
}

function is_assoc_array($var)
{
	if (!is_array($var)) {
		return false;
	}
	return array_keys($var) !== range(0, sizeof($var) - 1);
}

function get_namelist_from_objectlist($ol, $key = null, $val = null)
{
	if (!$ol) {
		return;
	}

	$name = array();
	if (!$key) {
		$key = "nname";
	}

	if ($val === null) {
		$val = $key;
	}

	foreach ($ol as $o) {
		if (!is_object($o)) {
			debugBacktrace();
		}
		$name[$o->$key] = $o->display($val);
	}
	return $name;
}

function convert_to_associate($ar)
{
	foreach ($ar as $k => $v)  $ret[$v] = $v;
	return $ret;
}

function get_namelist_from_arraylist($ol, $key = null, $val = null)
{
	$name = array();
	if (!$key) {
		$key = "nname";
	}

	if ($val === null) {
		$val = $key;
	}

	foreach ((array) $ol as $o) $name[$o[$key]] = $o[$val];

	return $name;
}

function isQuotaGreaterThanOrEq($used, $priv)
{
	if (is_unlimited($priv)) {
		return false;
	}
	if (is_unlimited($used)) {
		return true;
	}
	if (isOn($priv)) {
		return false;
	}
	if (isOn($used)) {
		return true;
	}
	return ($used >= $priv) ? true : false;
}

function isQuotaGreaterThan($used, $priv)
{
	if (is_unlimited($priv)) {
		return false;
	}
	if (is_unlimited($used)) {
		return true;
	}
	if (isOn($priv)) {
		return false;
	}
	if (isOn($used)) {
		return true;
	}
	return ($used > $priv) ? true : false;
}

function is_unlimited($val)
{
	if (strtolower($val) === 'unlimited' || strtolower($val) === 'na') {
		return true;
	}
	return false;
}

function if_demo_throw()
{
	if (if_demo()) {
		throw new lxException ("demo", '');
	}
}

function if_demo()
{
	global $gbl, $sgbl, $g_demo;
	return $g_demo;
}

function lx_phpdebug()
{
	global $gbl, $sgbl;

	if ($sgbl->dbg <= 0) {
		return;
	}
	if (!lfile_exists("/tmp/.php_debug")) {
		return;
	}

	$fp = lfopen("/tmp/.php_debug", "r");
	$s = fgets($fp, 1024);
	fclose($fp);

	$s = preg_replace("/--noraise /i", "", $s);
	$arr = parse_url($s);
	parse_str($arr['query'], $out);

	$ghtml->print_input("hidden", "start_debug", "1");
	$ghtml->print_input("hidden", "debug_port", $out['debug_port']);
	$ghtml->print_input("hidden", "debug_text_mode", "1");
	$ghtml->print_input("hidden", "debug_no_cache", "1095197145");
}

function create_simpleObject($arglist)
{
	$obj = new Remote();

	foreach ($arglist as $k => $v) {
		$obj->$k = $v;
	}
	return $obj;
}

function lx_sync()
{
	global $gbl, $sgbl, $login;
	$login->was();
}

function get_current_file()
{
	$n = basename(dirname($_SERVER['PHP_SELF']));
	return $n;
}

function array_flatten($a, $pref = null)
{
	$ret = array();
	foreach ($a as $i => $j) {
		if (is_array($j)) {
			$ret = array_merge($ret, array_flatten($j, "$pref$i"));
		} else {
			$ret["$pref$i"] = $j;
		}
	}
	return $ret;
}

function get_general_image_path($v = null)
{
	return add_http_host("/img/general/$v");
}

/**
 * @return void
 * @param
 * @param
 * @desc  part of the getting-image-through-http (to enable caching) madness.
 */
function add_http_host($elem)
{
	global $gbl, $sgbl, $login, $ghtml;
	return $elem;

	$host = $_SERVER['SERVER_NAME'];
	//$port = $sgbl->__var_prog_port;
	//$host = "http://" . $host . ":" .  "$port";
	//$host = "https://" . $host . ":" .  "$port";
	return $host . $elem;
}

function get_image_path($path = null)
{
	global $gbl, $sgbl, $login;

	//Return path of the encrypted images in the deployment version.
	# /img/image/collage//button//actionlog_list.gif
	return "/img/image/{$login->getSpecialObject('sp_specialplay')->icon_name}/$path";
}

function randomString($length)
{
	$randstr = '';
	$chars = array('a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z');
	for ($rand = 0; $rand <= $length; $rand++) {
		$random = rand(0, count($chars) - 1);
		$randstr .= $chars[$random];
	}
	return $randstr;
}

function DBG_GetBacktrace($traceArr)
{
	if ($sgbl->dbg < 0) {
		return;
	}

	$s = '';
	$MAXSTRLEN = 64;

	$s = '<pre align=left>';
	array_shift($traceArr);
	$tabs = sizeof($traceArr) - 1;
	foreach ($traceArr as $arr) {
		for ($i = 0; $i < $tabs; $i++) {
			$s .= ' &nbsp; ';
		}

		$tabs -= 1;
		$s .= '<font face="Courier New,Courier">';
		if (isset($arr['class'])) {
			$s .= $arr['class'] . '.';
		}
		$args = array();
		foreach ((array) $arr['args'] as $v) {
			if (is_null($v)) {
				$args[] = 'null';
			} else {
				if (is_array($v)) {
					$args[] = 'Array[' . sizeof($v) . ']';
				} else {
					if (is_object($v)) {
						$args[] = 'Object:' . get_class($v);
					} else {
						if (is_bool($v)) {
							$args[] = $v ? 'true' : 'false';
						} else {
							$v = (string) @$v;
							$str = htmlspecialchars(substr($v, 0, $MAXSTRLEN));
							if (strlen($v) > $MAXSTRLEN) $str .= '...';
							$args[] = "\"" . $str . "\"";
						}
					}
				}
			}
		}
		$s .= $arr['function'] . '(' . implode(',
        ', $args) . ')</font>';
		$Line = (isset($arr['line']) ? $arr['line'] : "unknown");
		$File = (isset($arr['file']) ? $arr['file'] : "unknown");
		$s .= sprintf("<font color=#808080 size=-1> # line
        %4d, file: <a href=\"file:/%s\">%s</a></font>", $Line, $File, $File);
		$s .= "\n";
	}
	$s .= '</pre>';
	return $s;
}

function getInfo($b)
{
	if (is_object($b) && is_subclass_of($b, 'lxclass')) {
		return $b->get__table() . ':' . $b->nname;
	} else {
		return $b;
	}
}

function backtrace_once()
{
	global $gbl, $sgbl, $login, $ghtml;
	if ($sgbl->dbg < 2) {
		return;
	}

	$v = debug_backtrace();
	$count = 0;
	$string = null;
	foreach ($v as $q) {
		$count++;
		if ($count === 1) {
			continue;
		}

		if ($count > 2) break;
		if ($count === 2 && (basename($q['file']) === 'sqlite.php')) {
			return null;
			continue;
		}
		$string .= $q['file'] . ":" . $q['line'] . ": " . $q['function'] . '(';
		if (isset($q['args'])) {
			foreach ($q['args'] as $a) {
				if (is_array($a)) {
					foreach ($a as $b) {
						if (is_array($b)) {
							foreach ($b as $c) {
								$string .= ', ' . getInfo($c);
							}
						} else {
							$string .= ', ' . getInfo($b);
						}
					}
				} else {
					$string .= $a;
				}
			}
		}
		$string .= ")<br>\n";
	}

	return $string;
}

function debugBacktrace($flag = false)
{
	global $gbl, $sgbl, $login, $ghtml;
	$string = null;

	if ($sgbl->dbg < 2) {
		return;
	}
	$v = debug_backtrace();
	foreach ($v as $q) 
	{
		$line = (isset($q['line'])) ? $q['line'] : '';
		$file = (isset($q['file'])) ? $q['file'] : '';
		$function = (isset($q['function'])) ? $q['function'] : '';
		
		$string .= $file . ":" . $line . ": " . $function . '(';
		
		if (isset($q['args'])) 
		{
			foreach ($q['args'] as $a) {
				if (is_array($a)) {
					foreach ($a as $b) {
						if (is_array($b)) {
							foreach ($b as $c) {
								$string .= ', ' . getInfo($c);
							}
						} else {
							$string .= ', ' . getInfo($b);
						}
					}
				} else {
					if (is_string($a)) {
						$string .= $a;
					}
				}
			}
		}
		$string .= ")<br>\n";
	}
	if ($flag) {
		return $string;
	}

	dprintr($string);
}

function lx_strip_tags($str)
{
	$nstr = strip_tags($str);

	$nstr = preg_replace("/\s+/", " ", $nstr);
	return $nstr;
}

class Language_Mes
{

}

function get_language()
{
	global $gbl, $sgbl, $login, $ghtml;
	if (is_object($login) && isset($login->getSpecialObject('sp_specialplay')->language)) {
		$lan = $login->getSpecialObject('sp_specialplay')->language;
	} else {
		$lan = 'en';
	}
	return $lan;
}

function get_charset()
{
	$lang = get_language();
	$charset = @ lfile_get_contents("lang/$lan/charset");
	$charset = trim($charset);
	return $charset;
}

function print_meta_lan()
{
	echo '<head>'.
    '    <meta http-equiv="Content-Type" content="text/html;charset=utf-8" />';
}

function init_language()
{
	global $gbl, $sgbl, $login, $ghtml;
	global $g_language_mes, $g_language_desc;

	$lan = get_language();

	if ($lan === 'en') {
		include_once "htmllib/lib/messagelib.php";
		include_once "htmllib/lib/helplib.php";
		include_once "htmllib/lib/helpvarlib.php";
		include_once "lib/messagelib.php";
		include_once "htmllib/lib/langfunctionlib.php";
		include_once "htmllib/lib/langkeywordlib.php";
	} else {
		if (lxfile_exists("lang/$lan/messagelib.php"))
		include_once "lang/$lan/messagelib.php"; else
		include_once "htmllib/lib/messagelib.php";

		if (lxfile_exists("lang/$lan/langfunctionlib.php")) {
			include_once "lang/$lan/langfunctionlib.php";
		} else {
			include_once "htmllib/lib/langfunctionlib.php";
		}

		if (lxfile_exists("lang/$lan/langkeywordlib.php")) {
			include_once "lang/$lan/langkeywordlib.php";
		} else {
			include_once "htmllib/lib/langkeywordlib.php";
		}
	}

	include_once "htmllib/lib/commonmessagelib.php";

	$g_language_mes = new Language_Mes();
	/*$g_language_mes->__information = $__information;
	 $g_language_mes->__emessage = $__emessage;
	$g_language_mes->__keyword = $__keyword;
	$g_language_mes->__help = $__help;
	$g_language_mes->__helpvar = $__helpvar;
	$g_language_mes->__commonhelp = $g_commonhelp;*/

	if ($lan === 'en') {
		//return;
	}
	include_once "lang/$lan/desclib.php";
	$g_language_desc = new Remote();
	//$g_language_desc->__description = $__description;
	//$g_language_desc->__acdescription = $__acdescription;
}

function lx_error_handler($errno, $errstr, $file, $line)
{
	global $gbl, $sgbl, $login, $ghtml;
	global $last_error;

	$last_error = $errstr;

	if ($sgbl->getDebugLevel() < 0) {
		return;
	}

	if (error_reporting() === 0) {
		return;
	}

	static $error = "";
	$pos = "$file:$line: $errstr";
	$error .= $pos . "\n";
	lfile_put_contents($sgbl->__var_error_file, $error);

	dprint("\n### PHP Error detected\n");
	dprint("### Notice: $errstr\n");
	dprint("### File:$file\n");
	dprint("### Line number: $line\n");
	dprint("### End PHP Error information\n\n");
}

/**
 * @return void
 * @param
 * @param
 * @desc Truly random and insane way to encrypt the image/form names so that hackers won't easily understand teh program structure, (which is clearly visible in these names...)
 */
function createEncName($name)
{
	global $gbl;

	return $name;

	if ($sgbl->dbg > 0) {
		return $name;
	}

	$name = str_replace("_", "", $name);
	$name = str_replace("php", "", $name);
	$name = str_replace("a", "r", $name);
	$name = str_replace("e", "z", $name);
	$name = str_replace("i", "q", $name);
	$name = str_replace("o", "j", $name);
	$name = str_replace("t", "y", $name);
	$name = str_replace("s", "x", $name);
	$name = str_replace("r", "p", $name);

	return $name;
}

function check_password($unenc, $enc)
{
	//Old Stuff Not reached
	return (crypt($unenc, $enc) === $enc);
}

function lx_exception_handler($e)
{
	global $gbl, $sgbl, $login, $ghtml;

	print("Notice : The resource you have requested doesn't exist. The server returned the error message: <br> ");

	print(" {$e->getMessage()} $e->variable $e->value ");
	print("<br>\n\n");

	if ($sgbl->dbg <= 0) {
		return;
	}
	$tr = $e->getTrace();
	$trace = "";
	foreach ($tr as $a) {
		$trace .= $a["file"] . ":" . $a["line"] . ":";
		if (isset($a["class"])) {
			$trace .= $a["class"] . ":";
		}
		$trace .= $a["function"] . "(";
		if (isset($a["args"])) {
			//$trace .= implode(",", $a['args']);
		}
		$trace .= ")\n";
	}
	lfile_put_contents($sgbl->__var_error_file, $trace);
}

function check_raw_password($class, $client, $pass)
{
	//return true;

	if (!empty($class) && !empty($client) && !empty($pass))
	{
    	$rawdb = new Sqlite(null, $class);
    	$password = $rawdb->rawquery("SELECT password FROM $class WHERE nname = '$client'");
    	$enp = $password[0]['password'];
    
    	if ($enp && check_password($pass, $enp))
    	{
    		return true;
    	}
	}

	return false;
	//$rawdb->close();
}

/**
 * @return void
 * @param
 * @param
 * @desc  Checks if the client is disabled and exits immedeiately showing a message.
 */
function check_if_disabled_and_exit()
{
	global $gbl, $sgbl, $login, $ghtml;

	if (!$login->isOn('cpstatus'))
	{
		$current_session = $gbl->getCurrentSession();
		 
		Utmp::updateUtmp($current_session->nname, $login, 'disabled');

		$ghtml->print_css_source('/htmllib/css/common.css');
		$ghtml->__http_vars['frm_emessage'] = 'This login has been Disabled. Please contact the administrator';
		$ghtml->print_message();

		$current_session->delete();
		$current_session->was();

		exit(0);
	}
}

function delete_expired_ssessions()
{
	global $gbl, $sgbl, $login, $ghtml;

	$s_l = $login->getList('ssessionlist');

	if(!empty($s_l))
	{
		foreach ($s_l as $s) 
		{
			if (!is_object($s)) 
			{
				continue;
			}
			
			$timeout = $s->last_access + $login->getSpecialObject('sp_specialplay')->ssession_timeout;
			
			dprint($s->nname);
			
			if ($timeout < time()) 
			{
				$s->delete();
				Utmp::updateUtmp($s->nname, $login, 'Session Expired');
			}
		}
	}
}

/**
 * @return void
 * @param
 * @param
 * @desc A generic function, that can be used by all programs. Does all the basic login stuff.
 */
function initProgramlib($ctype = null)
{
	global $gbl, $sgbl, $login, $ghtml;

	if ($sgbl->isSlave())
	{
		echo 'This is a Slave Server. Operate it at the Master server.' . PHP_EOL;
		exit;
	}

	$progname = $sgbl->getProductName();
	lfile_put_contents($sgbl->__var_error_file, '');
	set_exception_handler('lx_exception_handler');
	//xdebug_disable();
	set_error_handler('lx_error_handler');

	//setcookie("XDEBUG_SESSION", "sess");

	if ($ctype === 'superadmin')
	{
		$sgbl->setDataBaseFile($sgbl->__path_supernode_db);
		$sgbl->setAdminFilePass($sgbl->getSuperFilePass());
		$sgbl->setAdminUser($sgbl->__var_super_user);
		$login = new SuperClient(null, null, 'superadmin', 'login', 'forced');
		$login->get();
		return;
	}
	else if ($ctype === 'guest')
	{
		$login = new Client(null, null, '____________', 'guest');
		$login->get();
		return;
	}
	elseif ($ctype != '')
	{
		$login = new Client(null, null, $ctype, 'login', 'forced');
		$login->get();
		return;
	}

	$sessobj = NULL;

	if ($ghtml->frm_consumedlogin === 'true')
	{
		$clientname = $_COOKIE["$progname-consumed-clientname"];
		$classname = $_COOKIE["$progname-consumed-classname"];
		$session_id = $_COOKIE["$progname-consumed-session-id"];
		get_login($classname, $clientname);
		$login->__session_id = $session_id;
		$sessobj = $login->getObject('ssession');
	}
	else
	{
		if (isset($_COOKIE["$progname-session-id"]))
		{
			$clientname = $_COOKIE["$progname-clientname"];
			$classname = $_COOKIE["$progname-classname"];
			$session_id = $_COOKIE["$progname-session-id"];
			
			// Supernode
			if ($classname === 'superclient')
			{
				$sgbl->setDataBaseFile($sgbl->__path_supernode_db);
				$sgbl->setAdminFilePass($sgbl->getSuperFilePass());
				$sgbl->setAdminUser($sgbl->__var_super_user);
			}
			
			// Slave node
			if($classname === 'slave') $sgbl->setDataBaseFile($sgbl->__path_slave_db);

			if($classname)
			{
				get_login($classname, $clientname);
				$login->__session_id = $session_id;
				$sessobj = $login->getObject('ssession');
			}
		}
	}

	if (!$sessobj || $sessobj->dbaction === 'add') 
	{
		if ($ghtml->frm_ssl) {
			$ssl = unserialize(base64_decode($ghtml->frm_ssl));
			$string = $ssl['string'];
			$ssl_param = $ssl['ssl_param'];
			$encrypted_string = base64_decode($ssl['encrypted_string']);
			if (!$string || !checkPublicKey($string, $encrypted_string)) {
				print("SSL Connection Failed <br> \n");
				exit;
			}
			$class = 'client';
			$clientname = 'admin';
			get_login($class, $clientname);
			do_login($class, $clientname, $ssl_param);

			$sessobj = $gbl->getCurrentSession();
			$sessobj->write();
			$sessobj->dbaction = 'clean';
		}
	}

	//avoid some php warnings
	if (isset($login))
	{
		$gbl->client = $login->nname;
		$gbl->client_ttype = $login->cttype;
	}

	//dprintr($login->hpfilter);

	// This means the session object got created fresh.
	if (!$sessobj || $sessobj->dbaction === 'add') 
	{
		//dprint("Session id is empty. Clearing cookies and redirect to login.");
		clear_all_cookie();
		$ghtml->print_redirect_self('/login/');
	}

	$gbl->setCurrentSession($sessobj);

	if ($login->getClName() !== $sessobj->parent_clname)
	{
		dprint_r($login->ssession_l);
		dprint(" <br> $session_id <br> <br> <br> ");

		print("Session error! Login again.");

		clear_all_cookie();
		$ghtml->print_redirect_self('/login/?frm_emessage=sessionname_not_client');
	}

	$gen = $login->getObject('general')->generalmisc_b;

	if (!$gen->isOn('disableipcheck') && $_SERVER['REMOTE_ADDR'] != $sessobj->ip_address) 
	{
		$hostname = gethostbyaddr($_SERVER['REMOTE_ADDR']);
		log_message("An attempt to hack from $hostname (" . $_SERVER['REMOTE_ADDR'] . ") with sess $sessobj->nname, session ip: $sessobj->ip_address");

		if (!$gen->isOn('disableipcheck'))
		{
			clear_all_cookie();

			$current_session = $gbl->getCurrentSession();
			if ($current_session->ssl_param)
			{
				$current_session->delete();
				$current_session->write();
				$ghtml->print_redirect("{$current_session->ssl_param['backurl']}&frm_emessage=ipaddress_changed_amidst_session");
			}
			else
			{
				$ghtml->print_redirect_self("/login/?frm_emessage=ipaddress_changed_amidst_session");
			}
		}
	}

	if (intval($login->getSpecialObject('sp_specialplay')->ssession_timeout) <= 100) {
		$login->getSpecialObject('sp_specialplay')->ssession_timeout = 100;
		$login->setUpdateSubaction();
	}

	$timeout = $sessobj->last_access + $login->getSpecialObject('sp_specialplay')->ssession_timeout;
	$sessobj->timeout = $timeout;
	//$timeout  =  $sessobj->last_access + 4;
	$sessobj->last_access = time();
	$sessobj->setUpdateSubaction();

	if ($sessobj->auxiliary_id) {
		$aux = new Auxiliary(null, null, $sessobj->auxiliary_id);
		$aux->get();
		$login->__auxiliary_object = $aux;
	}

	if (time() > $timeout)
	{
		$sessobj->delete();
		$sessobj->write();
		//print("session error timeout");

		$current_session = $gbl->getCurrentSession();

		if ($current_session->ssl_param)
		{
			$ghtml->print_redirect("{$current_session->ssl_param['backurl']}&frm_emessage=session_timeout");
		}
		else
		{
			$ghtml->print_redirect_self('/login/?frm_emessage=session_timeout');
		}
	}

	addToUtmp($sessobj, 'update');
}

function clear_all_cookie()
{
	global $gbl, $sgbl, $login, $ghtml;

	$search = $sgbl->getProductName();

	if ($ghtml->frm_consumedlogin === 'true')
	{
		$search .= "-consumed";
	}

	foreach ($_COOKIE as $k => $v)
	{
		if (csb($k, $search))
		{
			setcookie($k, '', time() - 360000000);
		}
	}
}

function checkPublicKey($string, $encrypted_string)
{
	echo 'Checking public key' . PHP_EOL;

	$res = lfile_get_contents("__path_program_root/etc/authorized_keys");
	$public_key = $res;
	$pubkey_res = openssl_get_publickey($public_key);
	openssl_public_decrypt($encrypted_string, $decrypted_string, $public_key);

	if ($decrypted_string === $string)
	{
		return true;
	}

	return false;
}

function initSession($object, $ssl_param, $consuming_parent)
{
	global $gbl, $sgbl, $login, $ghtml;
	
	$session = randomString(50);
	$timestamp = time();
	//clear_all_cookie();
	// Making cookie persistent, otherwise IE will not pass it to new windows.
	// Needed in the file selector. Set the expiration to 10 years in the future.
	// Needed for brain damaged ie, which cannot recognize server time.
	$cookietime = $timestamp + 24 * 60 * 60 * 365 * 80;
	//$cookietime = 0;
	header('P3P: CP="CAO PSA OUR"');

	$progname = $sgbl->getProductName();
	$cookie_start = $progname;

	if ($consuming_parent) 
	{
		$cookie_start .= "-consumed";
	}

	if ($object->isAuxiliary()) 
	{
		$name = $object->__auxiliary_object->nname;
		$class = $object->__auxiliary_object->getClass();
	} 
	else 
	{
		$name = $object->nname;
		$class = $object->getClass();
	}

	setcookie("$cookie_start-clientname", $name, $cookietime, '/');
	setcookie("$cookie_start-classname", $class, $cookietime, '/');
	setcookie("$cookie_start-session-id", $session, $cookietime, '/');

	//dprint("Set cookies<br/>");

	$sessa['nname']            = $session;
	$sessa['ip_address']       = $_SERVER['REMOTE_ADDR'];
	$sessa['cttype']           = $object->getLoginType();
	$sessa['hostname']         = $_SERVER['REMOTE_ADDR']; // Hostname
	$sessa['tsessionid']       = randomString(30);
	// Login time is set to null.
	// This is set to the correct time inside display.php.
	// This allows us to figure out the first run of display.php.
	$sessa['logintime']        = $timestamp;
	$sessa['ssession_vars']    = array();
	$sessa['http_vars']        = array();
	$sessa['parent_clname']    = $object->getClName();
	$sessa['consuming_parent'] = $consuming_parent;
	$sessa['auxiliary_id']     = $object->getAuxiliaryId();
	$sessa['ssl_param']        = $ssl_param;
	
	if (intval($object->getSpecialObject('sp_specialplay')->ssession_timeout) <= 100)
	{
		$timeout = 100;
	}
	else
	{
		$timeout = $object->getSpecialObject('sp_specialplay')->ssession_timeout;
	}
	
	$sessa['timeout']     = $timestamp + $timeout;
	$sessa['last_access'] = $timestamp;
	
	$current_session = new Ssession(null, null, $session);
	$current_session->create($sessa);

	return $current_session;
}

function do_login($classname, $cgi_clientname, $ssl_param = null)
{
	global $gbl, $sgbl, $login, $ghtml;

	if (!$classname)
	{
		$classname = 'client';
	}

	$current_session = initSession($login, $ssl_param, NULL);

	$gbl->setCurrentSession($current_session);

	$login->addToList('ssession', $current_session);

	addToUtmp($current_session, 'add');

	if ($ghtml->frm_extra_var)
	{
		$extra = unserialize(base64_decode($ghtml->frm_extra_var));
		$gbl->setSessionV('extra_var', $extra);
	}
	
	//This is not the way. You have to periodically scan the utmp and delete eveyrthing that had expired.
	delete_expired_ssessions();
}

function isModifyAction()
{
	global $gbl, $sgbl, $login, $ghtml;
	if (array_search_bool(strtolower($ghtml->frm_action), array('show', 'updateform', 'addform', 'continue', 'list')) || array_search_bool($ghtml->frm_subaction, array("download"))) {
		return false;
	}
	return true;
}

/**
 * Get the lowercase class of a object
 * @param object $object The object
 * @return string The lowercase name of a object
 */
function lget_class($object)
{
	return strtolower(get_class($object));
}

/** Seems not used anymore, but could be useful
 * on other scripts o for script factory
 * Enter description here ...
 * @param unknown_type $cttype
 * @return Ambigous <number, NULL, string, mixed>
 */
function getAllclients($cttype = null)
{
	$db = new Sqlite(null, 'client');

	$list = $db->getTable(array('nname', 'cttype'));

	return $list;
}

function isLocalhost($var)
{
	if ($var && $var !== 'localhost')
	{
		return false;
	}
	return true;
}

function get_login($classname, $clientname)
{
	global $gbl, $sgbl, $login, $ghtml;

	if (!$classname) {
		print("There is no class. Login Error\n");
		exit;
	}

	$object = new $classname(null, null, $clientname, 'login');

	$ret = $object->get();

	if ($classname === 'auxiliary') {
		$login = $object->getParentO();
		$login->__auxiliary_object = $object;
	} else {
		$login = $object;
	}

	$login->__parent_o = null;
	return $ret;
}

/**
 * @return void
 * @param
 * @param
 * @desc  Remove unsavoury characters from a string so that it can be used as a variable.
 */
function fix_nname_to_be_variable($var)
{
	if (!$var) {
		return;
	}
	if (is_numeric($var[0])) {
		$var[0] = 'd';
	}
	$var = strtolower($var);
	return preg_replace("/[-\W ]/i", "_", $var);
}

function fix_nname_to_be_variable_without_lowercase($var)
{
	if (!$var) {
		return;
	}
	if (is_numeric($var[0])) {
		$var[0] = 'd';
	}
	return preg_replace("/[-\W ]/i", "_", $var);
}

function get_description($stuff)
{
	if (is_object($stuff))
	{
		$class = lget_class($stuff);
	}
	else
	{
		$class = $stuff;
	}

	$descr = get_classvar_description($class);
	return $descr[2];
}

function get_classvar_description($class, $var = null)
{
	global $gbl, $sgbl, $login, $ghtml;

	global $g_language_desc;
	global $g_language_mes;

	//$var = fix_nname_to_be_variable($var);
	if (csb($var, "__"))
	{
		$dvar = $var;
	} else {
		if ($var) {
			$dvar = "__desc_$var";
		} else {
			$dvar = "__desc";
		}
	}

	$rvar = strfrom($dvar, "__desc_");
	$rvar = strfrom($rvar, "__acdesc_");

	$class = strtolower($class);
	$ret = get_real_class_variable($class, $dvar);

	if (!$ret) {
		return null;
	}
	$ret['help'] = $ret[2];
	if (cse($dvar, "_o") || cse($dvar, "_l")) {
		return $ret;
	}
	if (!$g_language_desc) {
		return $ret;
	}

	/*
	 if ($login->getSpecialObject('sp_specialplay')->isCoreLanguage()) {
	return $ret;
	}
	*/

	$k = trim($ret[2], "_\n ");
	if (isset($g_language_desc->__description[$k])) {
		$ret[2] = $g_language_desc->__description[$k][0];
		if (isset($g_language_mes->__helpvar[$rvar])) {
			$ret['help'] = $g_language_mes->__helpvar[$rvar];
		} else if (isset($g_language_mes->__help[$dvar])) {
			$ret['help'] = $g_language_desc->__help[$k];
		} else {
			$ret['help'] = $ret[2];
		}
	}
	return $ret;
}

function get_var_help($var)
{
	global $g_language_mes, $g_language_desc;
	$cvar = strtolower($var);
	if (isset($g_language_mes->__help[$cvar])) {
		return $g_language_mes->__help[$cvar];
	}
	return $var;
}

function get_real_class_variable($class, $var)
{
	//$var = fix_nname_to_be_variable($var);
	$rclass = $class;
	$rclass = ucfirst($rclass);

	if (!class_exists($rclass)) {
		dprint("$rclass doesn't exist\n");
		return null;
	}

	$variable = "$rclass::\$" . $var;
	
	if (isset($variable)) 
	{ 
	    return $variable ; 
	} 
}

function get_class_variable($class, $var)
{
    $rclass = $class;

    $var = fix_nname_to_be_variable($var);
    $class = ucfirst($class);
    /*
     if (csa($class, '-')) {
    debugBacktrace();
    exit;
    }
    */

    //dprint('Class: ' . $class . PHP_EOL);
    //dprint('Var: ' . $var . PHP_EOL);
    
    if($var == '__table')
    {
        return isset($class::$__table) ? $class::$__table : NULL;
    }
    //$variable = "$class::\$" . $var;
    //return eval(" if (isset($variable)) { return $variable ; }  ");
    
    return property_exists($class, ${$var}) ? $class::${$var} : NULL;
}

function createZeroString($n)
{
    $string = "";
    for ($i = 0; $i < $n; $i++) {
        $string .= "0";
    }
    return $string;
}

/**
 * @return void
 * @param
 * @param
 * @desc  Execs a method inside a class. Passes all the variables to it. See the use of 2 evals.. Check documentation for lx_redefine_func;
 */
function exec_class_method($class, $func)
{
	global $gbl, $sgbl, $login, $ghtml;

	$rclass = $class;

	$class = strtolower($class);

	//Arg getting string is a function that needs $start to be set.
	$start = 2;

	$arglist = array();
	$num_args = @func_num_args();
	for ($i = $start; $i < $num_args; $i++)
	{
	    $arglist[] = func_get_arg($i);
	}

	// workaround for the following php bug:
	//   http://bugs.php.net/bug.php?id=47948
	//   http://bugs.php.net/bug.php?id=51329
	class_exists($class);
	// ---
	//dprint('Exec_class_method: Class:'. $class . 'Func:' . $func. 'Arglist');
	//print_r($arglist);
	return call_user_func_array(array($class, $func), $arglist);
}

function lxgettimewithoutyear($time)
{
	$curd = @ getdate(time());
	$date = @ getdate($time);

	//$month = ($date['month'] === $curd['month'])? "this Month": $date['month'];
	$month = substr($date['month'], 0, 3);

	if ($date['hours'] > 12) {
		$sess = "pm";
		//$hour = $date['hours'] - 12;
		$hour = $date['hours'];
	} else {
		$sess = "am";
		$hour = $date['hours'];
	}

	$minutes = $date['minutes'];

	if ($minutes < 10) {
		$minutes = "0" . $minutes;
	}

	$string = "$hour:$minutes {$date['mday']} $month";

	return $string;
}

function lxgettime($time)
{
	$curd = @ getdate(time());
	$date = @ getdate($time);

	$year = ($date['year'] === $curd['year']) ? "" : $date['year'];
	//$month = ($date['month'] === $curd['month'])? "this Month": $date['month'];
	$month = substr($date['month'], 0, 3);

	if ($date['hours'] > 12) {
		$sess = "pm";
		//$hour = $date['hours'] - 12;
		$hour = $date['hours'];
	} else {
		$sess = "am";
		$hour = $date['hours'];
	}

	$minutes = $date['minutes'];

	if ($minutes < 10) {
		$minutes = "0" . $minutes;
	}

	$string = $hour . ":" . $minutes . " " . $date['mday'] . " " . $month . " " . $year;

	return $string;
}

function if_search_continue($obj)
{
	global $gbl, $sgbl, $ghtml;
	if (isset($ghtml->__http_vars['frm_searchstring']) && !stristr($obj->{$obj->searchVar()}, $ghtml->frm_searchstring)) {
		return 1;
	} else {
		return 0;
	}
}

function add_disabled($list)
{
	$newlist[] = "--Disabled--";
	$newlist = lx_merge_good($newlist, $list);
	return $newlist;
}

function fix_disabled($value, $disabled_val)
{
	if ($value === "--Disabled--") {
		return $disabled_val;
	} else {
		return $value;
	}
}

function array_remove_assoc(&$array, $element)
{
	foreach ($array as $key => $value) {
		if ($value === $element)
		unset($array[$key]);
	}
}

function array_remove_object($objectlist, $variable, $value)
{
	foreach ($objectlist as $object) {
		if ($object->$variable != $value) {
			$ret[$object->nname] = $object;
		}
	}
	return $ret;
}

function add_slave($pass)
{
	global $gbl, $sgbl, $login, $ghtml;

	$client = new Slave(null, null, 'slave');
	$client->initThisDef();

	$ddb = new Sqlite(null, 'slave');

	if (!$ddb->existInTable('nname', 'slave'))
	{
		$res['password'] = $pass;
		$res['cttype'] = 'slave';

		if (if_demo())
		{
			$res['email'] = "admin@example.org";
		}

		$client->create($res);
		$client->write();
	}
}

function pad_to_length($var, $len)
{
	$times = round(strlen($var) / $len) + 1;
	$in = str_pad($var, 2048 * $times - strlen($var));
	return $in;
}

function remote_http_exec($server, $port, $rmt)
{
	$var = base64_encode(serialize($rmt));
	$res = send_to_some_http_server($server, "", $port, $var);

	$res = unserialize(base64_decode($res));

	if ($res->exception) {
		throw $res->exception;
	}
	return $res->ddata;
}

function send_to_some_http_server($raddress, $socket_type, $port, $var)
{
	global $gbl, $sgbl, $login, $ghtml;

	print_time('server');

	$ch = curl_init("http://$raddress:$port/lbin/remote.php");
	curl_setopt($ch, CURLOPT_POST, true);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
	curl_setopt($ch, CURLOPT_POSTFIELDS, "frm_rmt=$var&");
	$totalout = curl_exec($ch);
	dprint(curl_error($ch));
	$totalout = trim($totalout);
	return $totalout;
}

function check_remote_pass($user, $pass)
{
	global $gbl, $sgbl, $login, $ghtml;
	return check_password($pass, $login->password);
}

function lfile($arg)
{
	return lx_redefine_func("file", $arg);
}

function getNthToken($string, $num, $delim = ':')
{
	if (csa($string, $delim)) {
		$_tlist = explode($delim, $string);
		return $_tlist[$num];
	}
	return $string;
}

/**
 * @return void
 * @param unknown
 * @param unknown
 * @desc Recurses a dir tree and execs the '$func' on all the files AND the directories.
 */
function recurse_dir($dir, $func, $arglist = null)
{
	$list = lscandir($dir);
	if (!$list) {
		return;
	}
	foreach ($list as $file) {
		if ($file === "." || $file === "..") {
			continue;
		}
		$path = $dir . "/" . $file;
		if (lis_dir($path)) {
			recurse_dir($path, $func, $arglist);
		}
		/// After a successfuul recursion, you have to call the $func on the directory itself. So $func is called whether $path is both directory OR a file.
		$narglist[] = $path;
		foreach ((array) $arglist as $a) {
			$narglist[] = $a;
		}
		call_user_func_array($func, $narglist);
	}
}

function do_recurse_dir($dir, $func)
{
	$list = lscandir($dir);
	if (!$list) {
		return;
	}
	foreach ($list as $file) {
		if ($file === "." || $file === "..") {
			continue;
		}
		$path = $dir . "/" . $file;
		if (lis_dir($path)) {
			do_recurse_dir($path, $func);
		}
		$func($path);
	}
}

function getFromAny($list, $class, $name)
{
	$v = null;
	foreach ($list as $ob) {
		if (!$ob) {
			continue;
		}
		try {
			$v = $ob->getFromList($class, $name);
			return $v;
		} catch (exception $e) {
		}
	}
	return $v;
}

function array_get_object($objectlist, $variable, $value)
{
	foreach ($objectlist as $object)
	if ($object->$variable === $value) {
		return $object;
	}

	return NULL;
}

function getBasicServiceList()
{
	global $gbl, $sgbl, $login, $ghtml;
	$serv[] = $sgbl->__var_programname_web;
	$descr[$sgbl->__var_programname_web] = "Web Server";
	$serv[] = $sgbl->__var_programname_dns;
	$descr[$sgbl->__var_programname_dns] = "Name Server";
	$serv[] = "lxmail";
	$descr['lxmail'] = "Mail Server";
	return array($serv, $descr);
}

function getDbvariable($listvar, $mainvar)
{
	static $var;

	if (!$var) {
		$var = unserialize(lfile_get_contents("__path_dbschema"));
	}

	if (isset($var[$listvar][$mainvar])) {
		return $var[$listvar][$mainvar];
	} else {
		dprint("NO schema for $listvar $mainvar <br> \n");
		return null;
	}
}

function check_file_if_owned_by($file, $user)
{
	if (!lxfile_exists($file)) {
		return true;
	}

	if (csa($user, ":")) {
		$ruser = strtil($user, ":");
	} else {
		$ruser = $user;
	}
	$stat = lxfile_stat($file, false);
	$uid = $stat['uid'];
	$name = os_get_user_from_uid($uid);
	if ($name === $ruser) {
		return true;
	}
	log_log("file_check", "$file not owned by $ruser");
	return false;
}

function change_db_pass()
{
	global $gbl, $sgbl, $login, $ghtml;
	
	$pass = randomString(10);
	$newp = client::createDbPass($pass);
	$oldpass = lfile_get_contents($sgbl->getAdminFilePass());

	$username = $sgbl->getProductName();

	$sql = new Sqlite(null, 'client');

	//$sql->rawQuery("grant all on kloxo.* to kloxo@'localhost' identified by $newp");
	//$sql->rawQuery("grant all on kloxo.* to kloxo@'%' identified by $newp");
	//$return = $sql->setPassword($newp);
	//exec("mysqladmin -u $username -p$oldpass password $newp 2>&1", $out, $return);

	exec("echo 'set Password=Password(\"$newp\")' | mysql -u $username -p$oldpass 2>&1", $out, $return);

	if ($return)
	{
		$out = implode(" ", $out);
		log_log('admin_error', "mysql change password Failed $out");
		throw new lxException ('could_not_change_admin_pass', '', $out);
	}

	$return = lfile_put_contents($sgbl->getAdminFilePass(), $newp);

	if (!$return)
	{
		log_log("admin_error", "Admin pass change failed  $last_error");
		throw new lxException ("could_not_change_admin_pass", '', $last_error);
	}
}

function create_database()
{
	global $gbl, $sgbl, $login, $ghtml;

	static $_quota_var, $_field_var;

	$var['quotavar'] = NULL;
	$var['fieldvar'] = NULL;

	lfile_put_contents("__path_dbschema", serialize($var));

	$database = new Sqlite(null, 'sqlite');
	

    $full_query = '
    DROP TABLE IF EXISTS loginattempt;
    CREATE TABLE loginattempt (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, count varchar(255), client_name varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_loginattempt ON loginattempt (parent_clname (255));
    
    DROP TABLE IF EXISTS blockedip;
    CREATE TABLE blockedip (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, ipaddress varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_blockedip ON blockedip (parent_clname (255));
    
    DROP TABLE IF EXISTS allowedip;
    CREATE TABLE allowedip (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, ipaddress varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_allowedip ON allowedip (parent_clname (255));
    
    DROP TABLE IF EXISTS ssession;
    CREATE TABLE ssession (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, cttype varchar(255), ip_address varchar(255), timeout varchar(255), last_access varchar(255), logintime varchar(255), ser_http_vars longtext, ser_ssession_vars longtext, tsessionid varchar(255), auxiliary_id varchar(255), ser_ssl_param longtext, consuming_parent varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_ssession ON ssession (parent_clname (255));
    
    DROP TABLE IF EXISTS utmp;
    CREATE TABLE utmp (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, ssession_name varchar(255), cttype varchar(255), logintime varchar(255), timeout varchar(255), logouttime varchar(255), ip_address varchar(255), logoutreason varchar(255), auxiliary_id varchar(255), consuming_parent varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_utmp ON utmp (parent_clname (255));
    
    DROP TABLE IF EXISTS lxupdate;
    CREATE TABLE lxupdate (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, schedule varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_lxupdate ON lxupdate (parent_clname (255));
    
    DROP TABLE IF EXISTS version;
    CREATE TABLE version (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, major varchar(255), minor varchar(255), releasen varchar(255), extra varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_version ON version (parent_clname (255));
    
    
    ' . '' /* DOMAIN SETUP - COMMON */ . '
    DROP TABLE IF EXISTS notification;
    CREATE TABLE notification (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, ser_notflag_b longtext, text_newsubject longtext, text_newaccountmessage longtext, fromaddress varchar(255), coma_class_list text, PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_notification ON notification (parent_clname (255));
    
    DROP TABLE IF EXISTS ticketconfig;
    CREATE TABLE ticketconfig (
    nname varchar(255) NOT NULL, 
    parent_clname varchar(255), 
    parent_cmlist text, 
    ticketid varchar(255), 
    ser_category_list_a longtext, 
    mail_account varchar(255), 
    mail_server varchar(255), 
    mail_password varchar(255), 
    mail_period varchar(255), 
    mail_enable varchar(255), 
    mail_ssl_flag varchar(255), 
    PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_ticketconfig ON ticketconfig (parent_clname (255));
     
    DROP TABLE IF EXISTS ticket;
    CREATE TABLE ticket (nname varchar(255) NOT NULL, parent_clname varchar(255), 
    parent_cmlist text, password varchar(255), escalate varchar(255), 
    realpass varchar(255), status varchar(255), cpstatus varchar(255), 
    state varchar(255), priority varchar(255), responsible varchar(255), 
    made_by varchar(255), sent_to varchar(255), date_modified varchar(255), 
    unread_flag varchar(255), history_num varchar(255), subject varchar(255), 
    category varchar(255), ddate varchar(255), mail_messageid varchar(255), 
    PRIMARY KEY (nname (255)));
	CREATE INDEX parent_clname_ticket ON ticket (parent_clname (255));
    
	DROP TABLE IF EXISTS smessage;
    CREATE TABLE smessage (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, made_by varchar(255), text_readby_cmlist longtext, text_sent_to_cmlist longtext, subject varchar(255), text_description longtext, category varchar(255), ddate varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_smessage ON smessage (parent_clname (255));

    DROP TABLE IF EXISTS tickethistory;
    CREATE TABLE tickethistory (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, made_by varchar(255), state_from varchar(255), state varchar(255), text_reason longtext, ddate varchar(255), from_ad varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_tickethistory ON tickethistory (parent_clname (255));

    DROP TABLE IF EXISTS interface_template;
    CREATE TABLE interface_template (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, ser_domain_show_list longtext, ser_client_show_list longtext, ser_vps_show_list longtext, PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_interface_template ON interface_template (parent_clname (255));

    DROP TABLE IF EXISTS general;
    CREATE TABLE general (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, ser_generalmisc_b longtext, ser_helpdeskcategory_a longtext, ser_reversedns_b longtext, ser_selfbackupparam_b longtext, ser_hackbuttonconfig_b longtext, ser_customaction_b longtext, text_maintenance_message longtext, ser_portconfig_b longtext, ser_kloxoconfig_b longtext, ser_browsebackup_b longtext, login_pre varchar(255), ser_lxadminconfig_b longtext, disable_admin varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_general ON general (parent_clname (255));

    
    
    DROP TABLE IF EXISTS sslcert;
    CREATE TABLE sslcert (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, upload_status varchar(255), certname varchar(255), syncserver varchar(255), ser_ssl_data_b longtext, text_crt_content longtext, text_key_content longtext, text_csr_content longtext, text_ca_content longtext, oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_sslcert ON sslcert (parent_clname (255));

    DROP TABLE IF EXISTS ndsktoolbar;
    CREATE TABLE ndsktoolbar (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, ddate varchar(255), ttype varchar(255), description varchar(255), external varchar(255), vpsparent_clname varchar(255), url varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_ndsktoolbar ON ndsktoolbar (parent_clname (255));

    DROP TABLE IF EXISTS ndskshortcut;
    CREATE TABLE ndskshortcut (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, ddate varchar(255), ttype varchar(255), sortid varchar(255), separatorid varchar(255), description varchar(255), external varchar(255), vpsparent_clname varchar(255), url varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_ndskshortcut ON ndskshortcut (parent_clname (255));
    
    DROP TABLE IF EXISTS sshconfig;
    CREATE TABLE sshconfig (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, ssh_port varchar(255), without_password_flag varchar(255), disable_password_flag varchar(255), config_flag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_sshconfig ON sshconfig (parent_clname (255));

    DROP TABLE IF EXISTS rdnsrange;
    CREATE TABLE rdnsrange (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, firstip varchar(255), lastip varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_rdnsrange ON rdnsrange (parent_clname (255));

    DROP TABLE IF EXISTS lxguard;
    CREATE TABLE lxguard (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, configure_flag varchar(255), disablehit varchar(255), syncserver varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_lxguard ON lxguard (parent_clname (255));

    DROP TABLE IF EXISTS lxguardhit;
    CREATE TABLE lxguardhit (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, access varchar(255), service varchar(255), ddate varchar(255), ipaddress varchar(255), user varchar(255), syncserver varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_lxguardhit ON lxguardhit (parent_clname (255));
        
    DROP TABLE IF EXISTS lxguardwhitelist;
    CREATE TABLE lxguardwhitelist (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, ipaddress varchar(255), syncserver varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_lxguardwhitelist ON lxguardwhitelist (parent_clname (255));

    DROP TABLE IF EXISTS customaction;
    CREATE TABLE customaction (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, class varchar(255), action varchar(255), subaction varchar(255), exec varchar(255), where_to_exec varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_customaction ON customaction (parent_clname (255));

    DROP TABLE IF EXISTS custombutton;
    CREATE TABLE custombutton (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, status varchar(255), class varchar(255), title varchar(255), url varchar(255), description varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_custombutton ON custombutton (parent_clname (255));

    DROP TABLE IF EXISTS skipbackup;
    CREATE TABLE skipbackup (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, clname varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_skipbackup ON skipbackup (parent_clname (255));

    DROP TABLE IF EXISTS actionlog;
    CREATE TABLE actionlog (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, login varchar(255), loginclname varchar(255), auxiliary_id varchar(255), ipaddress varchar(255), class varchar(255), objectname varchar(255), action varchar(255), subaction varchar(255), ddate varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_actionlog ON actionlog (parent_clname (255));
    
    

    DROP TABLE IF EXISTS module;
    CREATE TABLE module (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, status varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_module ON module (parent_clname (255));
    
	' . '' /* Both child and normal share the same internal class */ . '
    DROP TABLE IF EXISTS sp_specialplay;
    CREATE TABLE sp_specialplay (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, ser_specialplay_b longtext, PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_sp_specialplay ON sp_specialplay (parent_clname (255));

    DROP TABLE IF EXISTS sp_childspecialplay;
    CREATE TABLE sp_childspecialplay (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, ser_specialplay_b longtext, PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_sp_childspecialplay ON sp_childspecialplay (parent_clname (255));

    DROP TABLE IF EXISTS sp_lstclass;
    CREATE TABLE sp_lstclass (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, ser_lst_client_list longtext, ser_lst_vps_list longtext, PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_sp_lstclass ON sp_lstclass (parent_clname (255));

    DROP TABLE IF EXISTS clienttemplate;
    CREATE TABLE clienttemplate (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, ser_priv longtext, share_status varchar(255), disable_per varchar(255), skin_name varchar(255), description varchar(255), ddate varchar(255), ser_listpriv longtext, ttype varchar(255), ser_dnstemplate_list longtext, PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_clienttemplate ON clienttemplate (parent_clname (255));

    DROP TABLE IF EXISTS resourceplan;
    CREATE TABLE resourceplan (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, realname varchar(255), ser_priv longtext, description varchar(255), ddate varchar(255), ser_listpriv longtext, ser_dnstemplate_list longtext, status varchar(255), disable_per varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_resourceplan ON resourceplan (parent_clname (255));

    DROP TABLE IF EXISTS domaintemplate;
    CREATE TABLE domaintemplate (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, ser_priv longtext, share_status varchar(255), disable_per varchar(255), skin_name varchar(255), description varchar(255), ddate varchar(255), ser_listpriv longtext, ttype varchar(255), ser_dnstemplate_list longtext, dnstemplate varchar(255), ipaddress varchar(255), redirect_domain varchar(255), catchall varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_domaintemplate ON domaintemplate (parent_clname (255));

    DROP TABLE IF EXISTS dnstemplate;
    CREATE TABLE dnstemplate (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, ser_mx_rec_a longtext, ser_ns_rec_a longtext, ser_a_rec_a longtext, ser_cn_rec_a longtext, ser_txt_rec_a longtext, ttl varchar(255), soanameserver varchar(255), zone_type varchar(255), ser_dns_record_a longtext, webipaddress varchar(255), mmailipaddress varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_dnstemplate ON dnstemplate (parent_clname (255));

    DROP TABLE IF EXISTS serverweb;
    CREATE TABLE serverweb (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, php_type varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_serverweb ON serverweb (parent_clname (255));

    DROP TABLE IF EXISTS watchdog;
    CREATE TABLE watchdog (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, servicename varchar(255), syncserver varchar(255), port varchar(255), action varchar(255), status varchar(255), added_by_system varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_watchdog ON watchdog (parent_clname (255));
    
    DROP TABLE IF EXISTS client;
    CREATE TABLE client (nname varchar(255) NOT NULL, parent_clname varchar(255), 
    parent_cmlist text, cttype varchar(255), ddate varchar(255), 
    ser_listpriv longtext, skeletonarchive varchar(255), 
    ser_dnstemplate_list longtext, disable_url varchar(255), 
    template_used varchar(255), username varchar(255), 
    realpass varchar(255), shell varchar(255), 
    password varchar(255), 
    default_domain varchar(255), resourceplan_used varchar(255), 
    websyncserver varchar(255), coma_dnssyncserver_list text, 
    mmailsyncserver varchar(255), mysqldbsyncserver varchar(255), 
    syncserver varchar(255), cron_mailto varchar(255), 
    dnstemplate_name varchar(255), corerootdir varchar(255), 
    disable_system_flag varchar(255), oldsyncserver varchar(255), 
    olddeleteflag varchar(255), 
    contactemail varchar(255), 
    priv_q_php_flag varchar(255),
    priv_q_addondomain_num varchar(255),
    priv_q_maindomain_num varchar(255),
    priv_q_rubyrails_num varchar(255),
    priv_q_rubyfcgiprocess_num varchar(255),
    priv_q_mysqldb_usage varchar(255),
    priv_q_phpfcgi_flag varchar(255),
    priv_q_phpfcgiprocess_num varchar(255),
    priv_q_subdomain_num varchar(255),
    priv_q_totaldisk_usage varchar(255),
    priv_q_php_manage_flag varchar(255),
    priv_q_installapp_flag varchar(255),
    priv_q_cron_minute_flag varchar(255),
    priv_q_document_root_flag varchar(255),
    priv_q_runstats_flag varchar(255),
    priv_q_webhosting_flag varchar(255),
    priv_q_can_change_limit_flag varchar(255),
    used_q_maindomain_num varchar(255),
    priv_q_can_change_password_flag varchar(255),
    priv_q_disk_usage varchar(255),
    used_q_domain_num varchar(255),
    priv_q_domain_num varchar(255),
    PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_client ON client (parent_clname (255));
    
    DROP TABLE IF EXISTS auxiliary;
    CREATE TABLE auxiliary (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, status varchar(255), realpass varchar(255), delete_flag varchar(255), pserver_flag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_auxiliary ON auxiliary (parent_clname (255));


	' . '' /* Domain Setup */ . '
    DROP TABLE IF EXISTS domaintraffic;
    CREATE TABLE domaintraffic (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, ddate varchar(255), oldtimestamp varchar(255), timestamp varchar(255), webtraffic_usage varchar(255), mailtraffic_usage varchar(255), ftptraffic_usage varchar(255), traffic_usage varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_domaintraffic ON domaintraffic (parent_clname (255));
    
    DROP TABLE IF EXISTS addondomain;
    CREATE TABLE addondomain (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, ttype varchar(255), destinationdir varchar(255), mail_flag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_addondomain ON addondomain (parent_clname (255));
    
    DROP TABLE IF EXISTS dirprotect;
    CREATE TABLE dirprotect (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, syncserver varchar(255), authname varchar(255), subweb varchar(255), path varchar(255), status varchar(255), ser_diruser_a longtext, oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_dirprotect ON dirprotect (parent_clname (255));

    DROP TABLE IF EXISTS dns;
    CREATE TABLE dns (nname varchar(255) NOT NULL, parent_clname varchar(255), 
    parent_cmlist text, syncserver varchar(255), serial varchar(255), 
    oldsyncserver varchar(255), olddeleteflag varchar(255), 
    ser_dns_record_a varchar(255),
    PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_dns ON dns (parent_clname (255));
    
    DROP TABLE IF EXISTS domain;
    CREATE TABLE domain (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, 
    ser_listpriv longtext, mmailpserver varchar(255), webpserver varchar(255), dnspserver varchar(255), 
    secdnspserver varchar(255), ttype varchar(255), ddate varchar(255), username varchar(255), 
    nameserver varchar(255), redirect_domain varchar(255), template_used varchar(255), 
    realpass varchar(255), dtype varchar(255), subdomain_parent varchar(255), 
    resourceplan_used varchar(255), previewdomain varchar(255), 
    priv_q_php_flag varchar(255),
    priv_q_installapp_flag varchar(255),
    priv_q_php_manage_flag varchar(255),
    priv_q_totaldisk_usage varchar(255),
    priv_q_disk_usage varchar(255),
    PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_domain ON domain (parent_clname (255));

    DROP TABLE IF EXISTS mailaccount;
    CREATE TABLE mailaccount (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, realpass varchar(255), syncserver varchar(255), forward_status varchar(255), ser_forward_a longtext, autorespond_status varchar(255), autores_name varchar(255), filter_spam_status varchar(255), no_local_copy varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_mailaccount ON mailaccount (parent_clname (255));

    DROP TABLE IF EXISTS domaindefault;
    CREATE TABLE domaindefault (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, remove_processed_stats varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_domaindefault ON domaindefault (parent_clname (255));
    
    DROP TABLE IF EXISTS web;
    CREATE TABLE web (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, 
    status varchar(255), iisid varchar(255), ser_server_alias_a longtext, 
    ser_subweb_a longtext, ser_redirect_a longtext, stats_username varchar(255), 
    stats_password varchar(255), ttype varchar(255), username varchar(255), 
    password varchar(255), ipaddress varchar(255), ser_webmisc_b longtext, 
    redirect_domain varchar(255), text_extra_tag longtext, 
    ser_customerror_b longtext, frontpage_flag varchar(255), 
    syncserver varchar(255), cron_mailto varchar(255), 
    ser_webindexdir_a longtext, webmail_url varchar(255), 
    text_lighty_rewrite longtext, ftpusername varchar(255), 
    hotlink_flag varchar(255), text_hotlink_allowed longtext, 
    hotlink_redirect varchar(255), remove_processed_stats varchar(255), 
    ser_indexfile_list longtext, fcgi_children varchar(255), 
    customer_name varchar(255), text_blockip longtext, 
    docroot varchar(255), 
    force_www_redirect varchar(255), oldsyncserver varchar(255), 
    olddeleteflag varchar(255), 
    priv_q_php_flag varchar(255), 
    priv_q_php_manage_flag varchar(255),
    priv_q_installapp_flag varchar(255),
    PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_web ON web (parent_clname (255));
    
    DROP TABLE IF EXISTS webmimetype;
    CREATE TABLE webmimetype (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, syncserver varchar(255), mimehandler varchar(255), extension varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_webmimetype ON webmimetype (parent_clname (255));
    
    DROP TABLE IF EXISTS webhandler;
    CREATE TABLE webhandler (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, syncserver varchar(255), mimehandler varchar(255), extension varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_webhandler ON webhandler (parent_clname (255));
    
    DROP TABLE IF EXISTS rubyrails;
    CREATE TABLE rubyrails (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, appname varchar(255), port varchar(255), syncserver varchar(255), accessible_directly varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_rubyrails ON rubyrails (parent_clname (255));
    
    DROP TABLE IF EXISTS mmail;
    CREATE TABLE mmail (nname varchar(255) NOT NULL, parent_clname varchar(255), 
    parent_cmlist text, webmailprog varchar(255), catchall varchar(255), 
    remotelocalflag varchar(255), catchall_status varchar(255), 
    username varchar(255), status varchar(255), 
    redirect_address varchar(255), syncserver varchar(255), 
    ttype varchar(255), redirect_domain varchar(255), 
    webmail_url varchar(255), systemuser varchar(255), 
    enable_spf_flag varchar(255), exclude_all varchar(255), 
    text_spf_domain longtext, text_spf_ip longtext, 
    oldsyncserver varchar(255), olddeleteflag varchar(255), 
    PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_mmail ON mmail (parent_clname (255));
    
    DROP TABLE IF EXISTS mailforward;
    CREATE TABLE mailforward (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, accountname varchar(255), forwardaddress varchar(255), syncserver varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_mailforward ON mailforward (parent_clname (255));

    DROP TABLE IF EXISTS mailaccount;
    CREATE TABLE mailaccount (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, realpass varchar(255), syncserver varchar(255), forward_status varchar(255), ser_forward_a longtext, autorespond_status varchar(255), autores_name varchar(255), filter_spam_status varchar(255), no_local_copy varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_mailaccount ON mailaccount (parent_clname (255));

    DROP TABLE IF EXISTS mailfilter;
    CREATE TABLE mailfilter (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, rule varchar(255), action varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_mailfilter ON mailfilter (parent_clname (255));
    
    DROP TABLE IF EXISTS reversedns;
    CREATE TABLE reversedns (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, reversename varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_reversedns ON reversedns (parent_clname (255));
    
    DROP TABLE IF EXISTS autoresponder;
    CREATE TABLE autoresponder (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, status varchar(255), send_rule varchar(255), reply_subject varchar(255), text_message longtext, autores_name varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_autoresponder ON autoresponder (parent_clname (255));
    
    DROP TABLE IF EXISTS mailinglist;
    CREATE TABLE mailinglist (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, syncserver varchar(255), listname varchar(255), adminemail varchar(255), lang varchar(255), post_members_only_flag varchar(255), post_moderated_flag varchar(255), post_moderator_only_flag varchar(255), archived_flag varchar(255), archive_blocked_flag varchar(255), archive_guarded_flag varchar(255), digest_flag varchar(255), jumpoff_flag varchar(255), subscriberlist_flag varchar(255), remote_admin_flag varchar(255), subscription_mod_flag varchar(255), edit_text_flag varchar(255), coma_mailinglist_mod_a text, text_trailer longtext, text_prefix longtext, max_msg_size varchar(255), min_msg_size varchar(255), text_mimeremove longtext, oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_mailinglist ON mailinglist (parent_clname (255));
    
    DROP TABLE IF EXISTS spam;
    CREATE TABLE spam (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, status varchar(255), spam_hit varchar(255), subject_tag varchar(255), ser_wlist_a longtext, ser_blist_a longtext, syncserver varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_spam ON spam (parent_clname (255));
    
    DROP TABLE IF EXISTS lxbackup;
    CREATE TABLE lxbackup (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, ftp_server varchar(255), ssh_server varchar(255), rm_username varchar(255), rm_password varchar(255), rm_directory varchar(255), upload_type varchar(255), send_email varchar(255), upload_to_ftp varchar(255), backupstage varchar(255), backuptype varchar(255), backupschedule_type varchar(255), rm_last_number varchar(255), ser_lxbackupmisc_b longtext, restorestage varchar(255), no_local_copy_flag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_lxbackup ON lxbackup (parent_clname (255));
    
    DROP TABLE IF EXISTS installsoft;
    CREATE TABLE installsoft (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, appname varchar(255), ddate varchar(255), dbprefix varchar(255), dbname varchar(255), installdir varchar(255), version varchar(255), dbhost varchar(255), realhost varchar(255), ser_installsoftmisc_b longtext, syncserver varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_installsoft ON installsoft (parent_clname (255));
    
    DROP TABLE IF EXISTS mimetype;
    CREATE TABLE mimetype (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, domainname varchar(255), type varchar(255), extension varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_mimetype ON mimetype (parent_clname (255));
	
	' . '' /* End Multi Server */ . '

	' . '' /* Semi Domain Setup */ . '
	
    DROP TABLE IF EXISTS mysqldb;
    CREATE TABLE mysqldb (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, primarydb varchar(255), username varchar(255), dbname varchar(255), dbtype varchar(255), dbpassword varchar(255), installsoft_flag varchar(255), installsoft_app varchar(255), syncserver varchar(255), password varchar(255), no_backup_flag varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_mysqldb ON mysqldb (parent_clname (255));

    DROP TABLE IF EXISTS mysqldbuser;
    CREATE TABLE mysqldbuser (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, username varchar(255), dbname varchar(255), dbpassword varchar(255), ser_dbpermission_b longtext, syncserver varchar(255), ser_dbhostlist_a longtext, password varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_mysqldbuser ON mysqldbuser (parent_clname (255));
    
    DROP TABLE IF EXISTS ipaddress;
    CREATE TABLE ipaddress (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, devname varchar(255), bproto varchar(255), ipaddr varchar(255), client_num varchar(255), shared varchar(255), netmask varchar(255), status varchar(255), userctl varchar(255), peerdns varchar(255), gateway varchar(255), itype varchar(255), ipv6init varchar(255), syncserver varchar(255), clientname varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_ipaddress ON ipaddress (parent_clname (255));
    
    DROP TABLE IF EXISTS domainipaddress;
    CREATE TABLE domainipaddress (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, domain varchar(255), ipaddr varchar(255), syncserver varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_domainipaddress ON domainipaddress (parent_clname (255));

    DROP TABLE IF EXISTS sslipaddress;
    CREATE TABLE sslipaddress (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, devname varchar(255), ipaddr varchar(255), sslclient varchar(255), ssldomain varchar(255), sslcert varchar(255), syncserver varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_sslipaddress ON sslipaddress (parent_clname (255));
    
    DROP TABLE IF EXISTS anonftpipaddress;
    CREATE TABLE anonftpipaddress (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, status varchar(255), syncserver varchar(255), ipaddr varchar(255), message varchar(255), anondomain varchar(255), ser_anonftpmisc_b longtext, disk_limit varchar(255), connection_limit varchar(255), download_limit varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_anonftpipaddress ON anonftpipaddress (parent_clname (255));

    DROP TABLE IF EXISTS serverftp;
    CREATE TABLE serverftp (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, maxclient varchar(255), highport varchar(255), lowport varchar(255), enable_anon_ftp varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_serverftp ON serverftp (parent_clname (255));
    
    DROP TABLE IF EXISTS odbc;
    CREATE TABLE odbc (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, odbcname varchar(255), description varchar(255), driver varchar(255), ser_odbcdetails_b longtext, syncserver varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_odbc ON odbc (parent_clname (255));
    
    DROP TABLE IF EXISTS uuser;
    CREATE TABLE uuser (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, realpass varchar(255), shellflag varchar(255), shell varchar(255), syncserver varchar(255), status varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_uuser ON uuser (parent_clname (255));
    
    DROP TABLE IF EXISTS ftpuser;
    CREATE TABLE ftpuser (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, realpass varchar(255), username varchar(255), directory varchar(255), syncserver varchar(255), ftp_disk_usage varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_ftpuser ON ftpuser (parent_clname (255));
    
    DROP TABLE IF EXISTS davuser;
    CREATE TABLE davuser (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, realpass varchar(255), username varchar(255), directory varchar(255), syncserver varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_davuser ON davuser (parent_clname (255));
    

    ' . '' /* System Setup */ . '
    
    DROP TABLE IF EXISTS service;
    CREATE TABLE service (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, servicename varchar(255), description varchar(255), grepstring varchar(255), syncserver varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_service ON service (parent_clname (255));
    
    DROP TABLE IF EXISTS llog;
    CREATE TABLE llog (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, syncserver varchar(255), email varchar(255), period varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_llog ON llog (parent_clname (255));

    ' . '' /* pserver can't be moved to common */ . '
    DROP TABLE IF EXISTS pserver;
    CREATE TABLE pserver (nname varchar(255) NOT NULL, parent_clname varchar(255), 
    parent_cmlist text, ostype varchar(255), osversion varchar(255), 
    dbadmin varchar(255), dbpassword varchar(255), realpass varchar(255), 
    username varchar(255), ser_rolelist longtext, cron_mailto varchar(255), 
    syncserver varchar(255), ser_pserverconf_b longtext, hostname varchar(255), 
    description varchar(255), realhostname varchar(255), timezone varchar(255), 
    coma_psrole_a text, load_threshold varchar(255), oldsyncserver varchar(255), 
    olddeleteflag varchar(255), 
    clientname varchar(255),
    PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_pserver ON pserver (parent_clname (255));

    DROP TABLE IF EXISTS phpini;
    CREATE TABLE phpini (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, php_manage_flag varchar(255), enable_zend_flag varchar(255), enable_ioncube_flag varchar(255), register_global_flag varchar(255), syncserver varchar(255), display_error_flag varchar(255), ser_phpini_flag_b longtext, oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_phpini ON phpini (parent_clname (255));
    
    DROP TABLE IF EXISTS driver;
    CREATE TABLE driver (nname varchar(255) NOT NULL, parent_clname varchar(255), 
    parent_cmlist text, ser_driver_b longtext, PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_driver ON driver (parent_clname (255));

    DROP TABLE IF EXISTS component;
    CREATE TABLE component (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, componentname varchar(255), syncserver varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_component ON component (parent_clname (255));
    
    DROP TABLE IF EXISTS servermail;
    CREATE TABLE servermail (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, smtp_instance varchar(255), enable_maps varchar(255), domainkey_flag varchar(255), additional_smtp_port varchar(255), queuelifetime varchar(255), concurrencyremote varchar(255), spamdyke_flag varchar(255), syncserver varchar(255), myname varchar(255), virus_scan_flag varchar(255), max_size varchar(255), greet_delay varchar(255), graylist_flag varchar(255), graylist_max_secs varchar(255), graylist_min_secs varchar(255), coma_mail_graylist_wlist_a text, max_rcpnts varchar(255), reject_unresolvable_rdns_flag varchar(255), reject_missing_sender_mx_flag varchar(255), reject_ip_in_cc_rdns_flag varchar(255), reject_empty_rdns_flag varchar(255), dns_blacklists varchar(255), alt_smtp_sdyke_flag varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_servermail ON servermail (parent_clname (255));
    
    DROP TABLE IF EXISTS serverspam;
    CREATE TABLE serverspam (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, status varchar(255), spam_hit varchar(255), subject_tag varchar(255), ser_wlist_a longtext, ser_blist_a longtext, syncserver varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_serverspam ON serverspam (parent_clname (255));

    DROP TABLE IF EXISTS cron;
    CREATE TABLE cron (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, syncserver varchar(255), email varchar(255), ser_minute longtext, ser_hour longtext, ser_ddate longtext, ser_month longtext, ser_weekday longtext, jobid varchar(255), username varchar(255), command varchar(255), argument varchar(255), ttype varchar(255), simple_cron varchar(255), cron_day_hour varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_cron ON cron (parent_clname (255));
    
    DROP TABLE IF EXISTS hostdeny;
    CREATE TABLE hostdeny (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, syncserver varchar(255), hostname varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_hostdeny ON hostdeny (parent_clname (255));
    
    DROP TABLE IF EXISTS dbadmin;
    CREATE TABLE dbadmin (nname varchar(255) NOT NULL, parent_clname varchar(255), 
    parent_cmlist text, dbtype varchar(255), dbadmin_name varchar(255), 
    dbpassword varchar(255), syncserver varchar(255), oldsyncserver varchar(255), 
    olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_dbadmin ON dbadmin (parent_clname (255));

    DROP TABLE IF EXISTS firewall;
    CREATE TABLE firewall (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, status varchar(255), id varchar(255), syncserver varchar(255), from_address varchar(255), from_port varchar(255), to_address varchar(255), to_port varchar(255), action varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_firewall ON firewall (parent_clname (255));
    
    DROP TABLE IF EXISTS proxy;
    CREATE TABLE proxy (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_proxy ON proxy (parent_clname (255));

    DROP TABLE IF EXISTS proxyacl;
    CREATE TABLE proxyacl (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, syncserver varchar(255), status varchar(255), ttype varchar(255), classid varchar(255), description varchar(255), password varchar(255), http varchar(255), ftp varchar(255), oldsyncserver varchar(255), olddeleteflag varchar(255), PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_proxyacl ON proxyacl (parent_clname (255));
    
    DROP TABLE IF EXISTS genlist;
    CREATE TABLE genlist (nname varchar(255) NOT NULL, parent_clname varchar(255), parent_cmlist text, ser_dirindexlist_a longtext, PRIMARY KEY (nname (255)));
    CREATE INDEX parent_clname_genlist ON genlist (parent_clname (255));
    
    ';

	$database->rawQuery($full_query);
}

function getQuotaListForClass($stuff, $res = null)
{
	if (is_object($stuff)) {
		$ob = $stuff;
	} else {
		$class = $stuff;
		$name = '__dummy__dummy__';
		$ob = new $class(null, null, $name);
		if ($res) {
			$ob->create($res);
		}
		$ob->priv = new Priv(null, null, $name);
	}
	return $ob->getQuotaVariableList();
}

function remove_extra_slash($file)
{
	return preg_replace("/\/+/", "/", $file);
}

function if_demo_throw_exception($where = null)
{
	global $gbl, $sgbl, $login, $ghtml;

	if ($sgbl->dbg < 0) {
		$where = null;
	}

	if (if_demo()) {
		throw new lxException("$where not_allowed_in_demo_version");
	}
}

function get_package_version($name)
{
	$cont = curl_general_get("http://download.quijost.com/download/version/$name");
	return trim($cont);
}

function getClassFromName($cgi_clientname)
{
	$classname = "client";

	if (csa($cgi_clientname, "@")) {
		$classname = "mailaccount";
	} elseif (csa($cgi_clientname, ".vps")) {
		$classname = "vps";
	} elseif (csa($cgi_clientname, ".vm")) {
		$classname = "vps";
	} elseif (csa($cgi_clientname, ".aux")) {
		$classname = "auxiliary";
	}
	/*
	 Domain user doesn't exist anymore....
	else if (csa($cgi_clientname, ".")) {
	$classname = "domain";
	}
	*/
	return $classname;
}

/* This is the only function that executes during the initialization.
The rest of the whole library exists as functions that can be called.
Nothing gets executed on their own, except this.
So it makes this sort of special */

if(!isset($sgbl)) $sgbl = new Sgbl();

if(!isset($gbl))
{
	require_once('lib/gbl.php');
	$gbl = new Gbl();
}

$gbl->get();

# [FIXME] Better call to a general isDemo function()
# Turn on demo version by putting a empty file called demo in the etc dir
if(lfile_exists($sgbl->getEtc() . '/demo')) $g_demo = 1;

check_for_debug('/commands.php');

$sgbl->setMethod(($sgbl->getDebugLevel() >= $sgbl::DEBUG_LITE) ? 'get' : 'post');