<?php
require_once 'lib/Singleton.php';

class ScriptFactory extends Singleton
{
	public static function getInstance()
	{
		return parent::getInstance(__CLASS__);
	}
	
	public function get($script)
	{
		switch($script)
		{
			case 'ResetPassword':
				require_once 'lib/scripts/ResetPassword.php';
				return new ResetPassword();
			break;
			case 'MakeMaster':
				require_once 'lib/scripts/MakeMaster.php';
				return new MakeMaster();
			break;
			case 'MakeSlave':
				require_once 'lib/scripts/MakeSlave.php';
				return new MakeSlave();
			break;
			case 'MakeSupernode':
				require_once 'lib/scripts/MakeSupernode.php';
				return new MakeSupernode();
			break;
			case 'Restart':
				require_once 'lib/scripts/Restart.php';
				return new Restart();
			break;
			default:
				echo 'Error: Script \'' . $script . '\' not available.' . PHP_EOL;
			break;
		}
	}
}