<?php

class ResetPassword
{
	private $argv      = NULL;
	private $options   = NULL;
	private $mode      = NULL;
	private $password  = NULL;
	
	public function __construct()
	{
		$this->checkRoot();
	}
	
	private function checkRoot()
	{
		require_once 'htmllib/lib/linux/lib.php';
		
		if(!os_isSelfSystemOrLxlabsUser()) 
		{ 
			echo 'Must be Root ' . PHP_EOL;
			exit;
		}
	}
	
	private function checkUsage()
	{
		// Define params
		$params  = array(
				   		 'mode:',     // Required value: [master|slave]
				    	 'password:', // Required value: [password]
						);
		
		// Get options
		$this->options = getopt(NULL, $params);
		
		// Check data
		if(!is_array($this->options) || empty($this->options))
		{
			$this->usage();
		}
		
		// Check mode param
		if(!isset($this->options['mode']))
		{
			$this->usage();
		}
		
		$this->mode = $this->options['mode'];
		
		// Check password param
		if(!isset($this->options['password']) || empty($this->options['password']))
		{
			$this->usage();
		}
		
		$this->password = $this->options['password'];
	}
	
	private function usage()
	{
		echo 'Usage: resetpassword --mode [master|slave] --password password' . PHP_EOL;
		exit(1);
	}
	
	public function run()
	{
		$this->checkUsage();
		
		# @todo Remove this require when it will be possible
		require_once 'lib/client/clientlib.php';
		require_once 'htmllib/lib/lib.php';
		require_once 'htmllib/phplib/lxlib.php';
		require_once 'htmllib/phplib/lib/client/client__synclib.php';
		require_once 'htmllib/phplib/lib/generallib.php';
		require_once 'htmllib/phplib/lib/client/appearancelib.php';
		require_once 'htmllib/lib/remotelib.php'; 
		
		switch($this->mode)
		{
			case 'master':
				initProgram('admin');
				//$login = new Client(null, null, 'admin');
				global $login;
				
				$login->password = crypt($this->password);
				$login->realpass = $this->password;
				$login->setUpdateSubaction('password');
				$login->createSyncClass();
				$login->was();
			break;
			case 'slave':
				require_once 'htmllib/lib/linux/lib.php';
				
				if (!lxfile_exists("__path_slave_db")) {
					print("Not Slave\n");
					exit;
				}
				
				$rmt = unserialize(lfile_get_contents('__path_slave_db'));
				$rmt->password = crypt($this->password);
				lfile_put_contents('__path_slave_db', serialize($rmt));
			break;
			default:
				echo 'First argument must be master or slave' . PHP_EOL;
				exit;
			break;
		}
	}
}